# Build and Run SgtDriverDemo 

* Go to folder Build and make scripts CMakeDbgxx executable
* On the command line enter 
```batch
./CmakeDbg32
```
 or 
 ```batch
 ./CmakeDbg64
 ```
 to 
create the 32bit/64bit version of the make file 

* Enter 
```batch
make
```

to build the executable. Folder Build should now contain the executable SgtDriverDemo


## Running SgtDriverDemo 

On the command line enter 
```batch
./SgtDriverDemo RESOURCESTRING
```

Where ```RESOURCESTRING``` is the resource string of your instrument e.g. 
- ```tcpip::IPADDRESS::instr``` (Visa) or
- ```tcpip::IPADDRESS::5025::socket``` (libsocketcontroller.so) or
- ```pcie::0x162f::0x1336::SERIALNO::instr``` (libpciecontroller.so)

```IPADDRESS``` is the IP address or hostname of your instrument and ```SERIALNO``` is its serial number. 

Make sure that Visa / libsocketcontroller.so / libpciecontroller.so are available. To make shared libraries libsocketcontroller.so and libpciecontroller.so accessible to the program you may use
```batch
export LD_LIBRARY_PATH=$(readlink ../../../SharedLibraries-Dlls/CentOS-64 -f)
 ```


## Fast Socket Channel

SgtDriverDemo can open a raw socket communication channel to the device which allows some commands to be sent much faster that with a textual protocol.
To take advantage of the fast socket channel: 

* Open a console as root

* Make shared library libsocketcontroller.so accessible e.g. by command 
```batch
export LD_LIBRARY_PATH=$(readlink ../../../SharedLibraries-Dlls/CentOS-64 -f)
 ```

* Run SgtDriverDemo with a socket resource string as described above or with ```tcpip``` as the resource string. With ```tcpip``` as the command argument SgtDriverDemo will search for all SGTs and display a list of all found devices. 


* Test whether the fast socket channel is used during a socket connection with command ```fm?```
 
 For more information go to 

 https://www.rohde-schwarz.com/applications/high-speed-remote-control-of-r-s-sgma-rf-sources-application-note_56280-241731.html