/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include "visa.h"

#define RSSGT_NAN                 9.91e+37
#define RSSGT_NAN_VI_INT32        0x80000000


ViStatus rssgt_InitAttributes (ViSession vi);
ViStatus rssgt_DefaultInstrSetup (ViSession openInstrSession);
ViStatus rssgt_CheckStatus (ViSession vi);
ViStatus rssgt_invalidViInt32Range (ViInt32 val, ViInt32 min, ViInt32 max);
ViStatus rssgt_invalidViUInt32Range (ViUInt32 val, ViUInt32 min, ViUInt32 max);
ViStatus rssgt_invalidViReal64Range (ViReal64 val, ViReal64 min, ViReal64 max);
ViStatus rssgt_invalidViBooleanRange (ViBoolean val);
ViStatus rssgt_SetOPCTimeout(ViSession   instrSession, ViInt32 timeout);
ViStatus rssgt_GetOPCTimeout(ViSession   instrSession, ViInt32 *timeout);
ViStatus rssgt_pathRepCap (ViSession instrSession, ViInt32 path, ViChar rep_cap[]);
unsigned int rssgt_AddPointer(void* pPtr);
void rssgt_RemovePointer(unsigned int handle);
void* rssgt_GetPointer(unsigned int handle);
ViStatus rssgt_readDataUnknownLength(ViSession instrSession,
                                     ViChar **outBuffer,
                                     ViUInt32 *count);

#if defined(LONG_MAX) && (LONG_MAX > 0x7FFFFFFFL)
  #define _PERCD "%d"
  #define _PERCLD "%ld"
  #define _PERCU "%u"
  #define _PERCUD "%ud"
  #define _PERC1U "%1u"
  #define _PERCX "%x"
  #define _PERCLX "%lx"
#else
  #define _PERCD "%ld"
  #define _PERCLD "%lld"
  #define _PERCU "%lu"
  #define _PERCUD "%lud"
  #define _PERC1U "%1lu"
  #define _PERCX "%lx"
  #define _PERCLX "%llx"
#endif