/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this source file. It is generated from DrBase repository.
 *
 *  Built on: 2019-07-30 15:01:04Z
 *****************************************************************************/

#include "rssgt.h"

 /*****************************************************************************
  *- Repeated Capabilities ---------------------------------------------------*
  *****************************************************************************/

RsRepCap rssgt_RsRepCapTable[] =
{
  /*
          {
          repCapName      ... Repeated capability name, e.g. "Channel"
          identifiers     ... Repeated capability identifiers (comma separated values), e.g. "Ch1,Ch2,Ch3"
          cmdValues       ... Command values (comma separated values), e.g. "1,2,3"
          },
  */

         {
          "ExternalTrigger",
          "EXT1,EXT2",
          "1,2"
         },
         {
          "Marker",
          "M1,M2",
          "1,2"
         },
         {
          "ARBCarrier",
          "Carrier1,Carrier2,Carrier3,Carrier4,Carrier5,Carrier6,Carrier7,Carrier8,Carrier9,Carrier10,Carrier11,Carrier12,Carrier13,Carrier14,Carrier15,Carrier16,Carrier17,Carrier18,Carrier19,Carrier20,Carrier21,Carrier22,Carrier23,Carrier24,Carrier25,Carrier26,Carrier27,Carrier28,Carrier29,Carrier30,Carrier31,Carrier32",
          "1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32"
         },
         {
          "User",
          "User1,User2,User3,User4",
          "1,2,3,4"
         },
         {
          "Path",
          "A,B",
          "1,2"
         },
         {
          "Sense",
          "S1,S2,S3,S4",
          "1,2,3,4"
         },
         {
          "IQOutput",
          "IQ0,IQ1",
          "0,1"
         },
         {
           NULL
         }
};

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/

static RsRangeTableEntry rssgt_rngPulseModulationPolarityEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NORM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"INV",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPulseModulationPolarity =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPulseModulationPolarityEntries
};

static RsRangeTableEntry rssgt_rngExternalTriggerSlopeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"POS",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NEG",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngExternalTriggerSlope =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngExternalTriggerSlopeEntries
};

static RsRangeTableEntry rssgt_rngReferenceOscillatorSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"INT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EXT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngReferenceOscillatorSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngReferenceOscillatorSourceEntries
};

static RsRangeTableEntry rssgt_rngReferenceOscillatorExternalFrequencyEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"5MHZ",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"10MHZ",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"13MHZ",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngReferenceOscillatorExternalFrequency =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngReferenceOscillatorExternalFrequencyEntries
};

static RsRangeTableEntry rssgt_rngClockSynchronisationModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NONE",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MAST",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SLAV",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DIIN",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngClockSynchronisationMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngClockSynchronisationModeEntries
};

static RsRangeTableEntry rssgt_rngTrgTriggerModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AUTO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"RETR",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AAUT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ARET",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SING",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngTrgTriggerMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngTrgTriggerModeEntries
};

static RsRangeTableEntry rssgt_rngClockModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SAMP",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MSAM",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngClockMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngClockModeEntries
};

static RsRangeTableEntry rssgt_rngARBExtendedTriggerModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SAME",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NEXT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NSE",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEQ",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBExtendedTriggerMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBExtendedTriggerModeEntries
};

static RsRangeTableEntry rssgt_rngARBSignalDurationUnitEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SAMP",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEQ",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBSignalDurationUnit =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBSignalDurationUnitEntries
};

static RsRangeTableEntry rssgt_rngARBMarkerModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"UNCH",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"REST",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PULS",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PATT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"RAT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMarkerMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMarkerModeEntries
};

static RsRangeTableEntry rssgt_rngARBMultisegmentLevelModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"UNCH",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ERMS",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMultisegmentLevelMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMultisegmentLevelModeEntries
};

static RsRangeTableEntry rssgt_rngARBSequenceRestartEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MRK1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MRK2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MRK3",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MRK4",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBSequenceRestart =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBSequenceRestartEntries
};

static RsRangeTableEntry rssgt_rngARBMultisegmentClockModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"UNCH",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"HIGH",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"USER",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMultisegmentClockMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMultisegmentClockModeEntries
};

static RsRangeTableEntry rssgt_rngARBMultiCarrierModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"EQU",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ARB",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMultiCarrierMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMultiCarrierModeEntries
};

static RsRangeTableEntry rssgt_rngARBMultiCarrierCrestFactorModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MAX",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMultiCarrierCrestFactorMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMultiCarrierCrestFactorModeEntries
};

static RsRangeTableEntry rssgt_rngARBSignalPeriodModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"LONG",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SHOR",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"USER",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LCM",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBSignalPeriodMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBSignalPeriodModeEntries
};

static RsRangeTableEntry rssgt_rngBBINModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"ANAL",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DIG",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngBBINMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngBBINModeEntries
};

static RsRangeTableEntry rssgt_rngImpedanceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"G50",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"G1K",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngImpedance =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngImpedanceEntries
};

static RsRangeTableEntry rssgt_rngSlopeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NEG",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POS",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSlope =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSlopeEntries
};

static RsRangeTableEntry rssgt_rngGlobalClockModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SYMB",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BIT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngGlobalClockMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngGlobalClockModeEntries
};

static RsRangeTableEntry rssgt_rngIMPOptimizationModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"FAST",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"QHIG",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIMPOptimizationMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIMPOptimizationModeEntries
};

static RsRangeTableEntry rssgt_rngAWGNModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"ADD",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ONLY",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"CW",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngAWGNMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngAWGNModeEntries
};

static RsRangeTableEntry rssgt_rngAWGNNoiseModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"CN",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SN",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngAWGNNoiseMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngAWGNNoiseModeEntries
};

static RsRangeTableEntry rssgt_rngUnitAngleEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"DEG",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"RAD",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngUnitAngle =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngUnitAngleEntries
};

static RsRangeTableEntry rssgt_rngUnitPowerEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"V",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DBM",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DBUV",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngUnitPower =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngUnitPowerEntries
};

static RsRangeTableEntry rssgt_rngSystemIPAddressModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"STAT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AUTO",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSystemIPAddressMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSystemIPAddressModeEntries
};

static RsRangeTableEntry rssgt_rngROSCSynchronizationBandwidthEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"WIDE",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NARR",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngROSCSynchronizationBandwidth =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngROSCSynchronizationBandwidthEntries
};

static RsRangeTableEntry rssgt_rngRFAttenuatorModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AUTO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FIX",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"APAS",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngRFAttenuatorMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngRFAttenuatorModeEntries
};

static RsRangeTableEntry rssgt_rngPowerOnStateEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"UNCH",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerOnState =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerOnStateEntries
};

static RsRangeTableEntry rssgt_rngALCEnabledEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"ONT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"OFFT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngALCEnabled =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngALCEnabledEntries
};

static RsRangeTableEntry rssgt_rngPULMPolarityEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NORM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"INV",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPULMPolarity =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPULMPolarityEntries
};

static RsRangeTableEntry rssgt_rngPULMSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"INT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EXT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPULMSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPULMSourceEntries
};

static RsRangeTableEntry rssgt_rngPULMExternalInputImpedanceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"G50",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"G10K",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPULMExternalInputImpedance =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPULMExternalInputImpedanceEntries
};

static RsRangeTableEntry rssgt_rngPULMTriggerModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AUTO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EXT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EGAT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPULMTriggerMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPULMTriggerModeEntries
};

static RsRangeTableEntry rssgt_rngIQOutputPowerOnStateEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"UNCH",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputPowerOnState =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputPowerOnStateEntries
};

static RsRangeTableEntry rssgt_rngTriggerSourEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"INT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EXT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngTriggerSour =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngTriggerSourEntries
};

static RsRangeTableEntry rssgt_rngClockSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"INT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EXT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngClockSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngClockSourceEntries
};

static RsRangeTableEntry rssgt_rngPULMModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SING",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DOUB",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPULMMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPULMModeEntries
};

static RsRangeTableEntry rssgt_rngALCDetectorSensitivityEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LOW",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MED",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"HIGH",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngALCDetectorSensitivity =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngALCDetectorSensitivityEntries
};

static RsRangeTableEntry rssgt_rngRFAttRFOFFModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"FIX",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MAX",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngRFAttRFOFFMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngRFAttRFOFFModeEntries
};

static RsRangeTableEntry rssgt_rngRFLevelModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NORM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LOWN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LOWD",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngRFLevelMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngRFLevelModeEntries
};

static RsRangeTableEntry rssgt_rngIQSMWAnalogWidebandGainEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"DBM3",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DBM4",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DBM2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DB0",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DB2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DB3",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */6,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DB4",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */7,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DB6",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */8,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DB8",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQSMWAnalogWidebandGain =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQSMWAnalogWidebandGainEntries
};

static RsRangeTableEntry rssgt_rngROSCOutputFrequencyEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"10MHZ",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"100MHZ",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"1000MHZ",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"13MHZ",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngROSCOutputFrequency =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngROSCOutputFrequencyEntries
};

static RsRangeTableEntry rssgt_rngRFLevSettCharacteristicEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AUTO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"UNIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MON",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"CVSW",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"USER",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngRFLevSettCharacteristic =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngRFLevSettCharacteristicEntries
};

static RsRangeTableEntry rssgt_rngOperationModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NORM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBBY",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngOperationMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngOperationModeEntries
};

static RsRangeTableEntry rssgt_rngAWGNDisplayModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"RF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BB",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngAWGNDisplayMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngAWGNDisplayModeEntries
};

static RsRangeTableEntry rssgt_rngAWGNPowerRefModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"CARR",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NOIS",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngAWGNPowerRefMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngAWGNPowerRefModeEntries
};

static RsRangeTableEntry rssgt_rngARBMCarPowerRefEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"RMS",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PEAK",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMCarPowerRef =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMCarPowerRefEntries
};

static RsRangeTableEntry rssgt_rngARBTriggerDelayUnitEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SAMP",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"TIME",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBTriggerDelayUnit =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBTriggerDelayUnitEntries
};

static RsRangeTableEntry rssgt_rngARBMultisegmentMarkerModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"IGN",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"TAKE",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMultisegmentMarkerMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMultisegmentMarkerModeEntries
};

static RsRangeTableEntry rssgt_rngBBINSRateSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"USER",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DIN",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngBBINSRateSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngBBINSRateSourceEntries
};

static RsRangeTableEntry rssgt_rngIQOutputDigitalStepModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"DEC",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"USER",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputDigitalStepMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputDigitalStepModeEntries
};

static RsRangeTableEntry rssgt_rngIQOutputDigitalSRateSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"USER",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DOUT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputDigitalSRateSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputDigitalSRateSourceEntries
};

static RsRangeTableEntry rssgt_rngConnectorOutputEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"REF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LO",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"OFF",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngConnectorOutput =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngConnectorOutputEntries
};

static RsRangeTableEntry rssgt_rngSystemEmodeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EM1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EM2",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSystemEmode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSystemEmodeEntries
};

static RsRangeTableEntry rssgt_rngFormatSequenceOfBytesEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NORM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SWAP",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngFormatSequenceOfBytes =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngFormatSequenceOfBytesEntries
};

static RsRangeTableEntry rssgt_rngFormatStatusRegisterEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"ASC",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"HEX",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"OCT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngFormatStatusRegister =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngFormatStatusRegisterEntries
};

static RsRangeTableEntry rssgt_rngFormatDataEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"ASC",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PACK",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngFormatData =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngFormatDataEntries
};

static RsRangeTableEntry rssgt_rngSystemSerialBaudEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */2400,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */4800,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */9600,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */19200,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */38400,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */57600,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */115200,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSystemSerialBaud =
{
  /* type        = */RS_VAL_COERCED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSystemSerialBaudEntries
};

static RsRangeTableEntry rssgt_rngSystemSerialParityEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NONE",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ODD",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EVEN",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSystemSerialParity =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSystemSerialParityEntries
};

static RsRangeTableEntry rssgt_rngSystemSerialStopBitsEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */1,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */0,
  /* maxValue           = */0,
  /* coercedValue       = */2,
  /* cmdString          = */NULL,
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSystemSerialStopBits =
{
  /* type        = */RS_VAL_COERCED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSystemSerialStopBitsEntries
};

static RsRangeTableEntry rssgt_rngIQOutputLevelEntryEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"PEP",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LEV",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputLevelEntry =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputLevelEntryEntries
};

static RsRangeTableEntry rssgt_rngTestExternalIQDevicesEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"IQIN",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"IQO",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngTestExternalIQDevices =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngTestExternalIQDevicesEntries
};

static RsRangeTableEntry rssgt_rngConnectorOperationModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"MKR1",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MKR2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"TRIG",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"CIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"COUT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */6,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SOUT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */7,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NEXT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */8,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LOW",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */9,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MLAT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */10,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MARR",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */11,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"HIGH",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */12,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SVAL",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */13,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SNV",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */14,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PVO",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */15,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PETR",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */16,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PEMS",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */17,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"TOUT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngConnectorOperationMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngConnectorOperationModeEntries
};

static RsRangeTableEntry rssgt_rngInputEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"G1K",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"G50",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"G10K",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngInput =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngInputEntries
};

static RsRangeTableEntry rssgt_rngNextSegmentEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NEXT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BLANK",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ENDL",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG0",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */6,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG3",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */7,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG4",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */8,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG5",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */9,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG6",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */10,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG7",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */11,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG8",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */12,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG9",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */13,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG10",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */14,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG11",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */15,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG12",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */16,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG13",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */17,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG14",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */18,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG15",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */19,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG16",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */20,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG17",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */21,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG18",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */22,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG19",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */23,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG20",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */24,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG21",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */25,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG22",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */26,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG23",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */27,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG24",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */28,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG25",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */29,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG26",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */30,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG27",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */31,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG28",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */32,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG29",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */33,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG30",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */34,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEG31",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngNextSegment =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngNextSegmentEntries
};

static RsRangeTableEntry rssgt_rngIQSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"ANAL",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BAS",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQSourceEntries
};

static RsRangeTableEntry rssgt_rngUserCorrectionImportExportExtensionEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"TXT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"CSV",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngUserCorrectionImportExportExtension =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngUserCorrectionImportExportExtensionEntries
};

static RsRangeTableEntry rssgt_rngUserCorrectionImportExportColumnSeparatorEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"TAB",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SEM",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"COMM",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SPAC",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngUserCorrectionImportExportColumnSeparator =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngUserCorrectionImportExportColumnSeparatorEntries
};

static RsRangeTableEntry rssgt_rngUserCorrectionImportExportDecimalSeparatorEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"DOT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"COMM",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngUserCorrectionImportExportDecimalSeparator =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngUserCorrectionImportExportDecimalSeparatorEntries
};

static RsRangeTableEntry rssgt_rngUserCorrectionImportExportModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"IMP",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EXP",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngUserCorrectionImportExportMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngUserCorrectionImportExportModeEntries
};

static RsRangeTableEntry rssgt_rngConnectorImpedanceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"G50",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"G10K",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngConnectorImpedance =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngConnectorImpedanceEntries
};

static RsRangeTableEntry rssgt_rngDigitalPredistortionLevelReferenceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"BDPD",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ADPD",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SDPD",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngDigitalPredistortionLevelReference =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngDigitalPredistortionLevelReferenceEntries
};

static RsRangeTableEntry rssgt_rngDigitalPredistortionShapingEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"TABL",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POLY",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NORM",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngDigitalPredistortionShaping =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngDigitalPredistortionShapingEntries
};

static RsRangeTableEntry rssgt_rngDigitalPredistortionInterpolationEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POW",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngDigitalPredistortionInterpolation =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngDigitalPredistortionInterpolationEntries
};

static RsRangeTableEntry rssgt_rngIQOutputAnalogTypeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SING",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DIFF",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputAnalogType =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputAnalogTypeEntries
};

static RsRangeTableEntry rssgt_rngIQOutputAnalogModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"FIX",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"VAR",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputAnalogMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputAnalogModeEntries
};


static RsRangeTableEntry rssgt_rngEnvelopeTrackingVoltageAdaptationEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AUTO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POW",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MAN",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingVoltageAdaptation =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingVoltageAdaptationEntries
};

static RsRangeTableEntry rssgt_rngEnvelopeTrackingeTrackInterfaceTypeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"USER",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ET1V2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ET1V5",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"ET2V0",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingeTrackInterfaceType =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingeTrackInterfaceTypeEntries
};

static RsRangeTableEntry rssgt_rngEnvelopeTrackingVoltageReferenceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"VCC",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"VOUT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingVoltageReference =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingVoltageReferenceEntries
};

static RsRangeTableEntry rssgt_rngEnvelopeTrackingTerminationEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"GRO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"WIRE",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingTermination =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingTerminationEntries
};

static RsRangeTableEntry rssgt_rngEnvelopeTrackingShapingEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POW",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DETR",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"TABL",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POLY",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingShaping =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingShapingEntries
};

static RsRangeTableEntry rssgt_rngEnvelopeTrackingDetroughingFunctionEntries[] =
{
  {
    /* discreteOrMinValue = */1,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"F1",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"F2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"F3",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingDetroughingFunction =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingDetroughingFunctionEntries
};

static RsRangeTableEntry rssgt_rngEnvelopeTrackingShapingInterpolationEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"OFF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LIN",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"POW",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEnvelopeTrackingShapingInterpolation =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEnvelopeTrackingShapingInterpolationEntries
};

static RsRangeTableEntry rssgt_rngEvenlopeTrackingShapingScaleEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"POW",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"VOLT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngEvenlopeTrackingShapingScale =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngEvenlopeTrackingShapingScaleEntries
};

static RsRangeTableEntry rssgt_rngTriggerNextSourEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"INT",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NEXT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngTriggerNextSour =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngTriggerNextSourEntries
};

static RsRangeTableEntry rssgt_rngSystemGPIBLineTerminatorEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"STAN",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"EOI",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngSystemGPIBLineTerminator =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngSystemGPIBLineTerminatorEntries
};

static RsRangeTableEntry rssgt_rngARBMultisegmentLevelEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"UNCH",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"HIGH",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngARBMultisegmentLevel =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngARBMultisegmentLevelEntries
};

static RsRangeTableEntry rssgt_rngIQOutputAnalogDisplayPowerViaEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"PEP",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"LEV",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputAnalogDisplayPowerVia =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngIQOutputAnalogDisplayPowerViaEntries
};

static RsRangeTableEntry rssgt_rngBBSystemConfigurationEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"STAN",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AFET",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngBBSystemConfiguration =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngBBSystemConfigurationEntries
};

static RsRangeTableEntry rssgt_rngBBPathEntries[] =
{
  {
    /* discreteOrMinValue = */1,
    /* maxValue           = */2,
    /* coercedValue       = */0,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngBBPath =
{
  /* type        = */RS_VAL_RANGED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngBBPathEntries
};

static RsRangeTableEntry rssgt_rngPowerUnitEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"DBM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"DBUV",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"WATT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerUnit =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerUnitEntries
};

static RsRangeTableEntry rssgt_rngPowerSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"RF",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"USER",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerSourceEntries
};

static RsRangeTableEntry rssgt_rngPowerDisplayPermanentEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AVER",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"PEAK",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerDisplayPermanent =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerDisplayPermanentEntries
};

static RsRangeTableEntry rssgt_rngPowerSPCSensorSelectEntries[] =
{
  {
    /* discreteOrMinValue = */1,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SENS1",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SENS2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SENS3",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SENS4",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerSPCSensorSelect =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerSPCSensorSelectEntries
};

static RsRangeTableEntry rssgt_rngPowerFilterModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"AUTO",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"USER",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"NSR",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerFilterMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerFilterModeEntries
};

static RsRangeTableEntry rssgt_rngPowerBasebandSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"BBA",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBC",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBD",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBINA",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBINB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */6,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADINPA",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */7,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADINPB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */8,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADINPC",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */9,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADINPD",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */10,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADOUTA",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */11,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADOUTB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */12,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADOUTC",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */13,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"FADOUTD",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */14,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AWGNA",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */15,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AWGNB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */16,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AWGNC",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */17,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AWGND",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */18,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"STREAMA",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */19,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"STREAMB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */20,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"STREAMC",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */21,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"STREAMD",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerBasebandSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerBasebandSourceEntries
};

static RsRangeTableEntry rssgt_rngPowerBasebandAcquisitionEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NOM",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"CONT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"GAT",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MGAT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerBasebandAcquisition =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerBasebandAcquisitionEntries
};

static RsRangeTableEntry rssgt_rngPowerBasebandGateSourceEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"NONE",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MARK1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MARK2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MARK3",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"MGAT",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerBasebandGateSource =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerBasebandGateSourceEntries
};

static RsRangeTableEntry rssgt_rngPowerBasebandOutputEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"RFA",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"RFB",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"IQOUT1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"IQOUT2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBMM1",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"BBMM2",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerBasebandOutput =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerBasebandOutputEntries
};

static RsRangeTableEntry rssgt_rngPowerBasebandRunModeEntries[] =
{
  {
    /* discreteOrMinValue = */0,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SING",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */1,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"AUTO",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerBasebandRunMode =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerBasebandRunModeEntries
};

static RsRangeTableEntry rssgt_rngIQOutputImpairmentsPhaseOffsetEntries[] =
{
  {
    /* discreteOrMinValue = */-1000,
    /* maxValue           = */1000,
    /* coercedValue       = */0,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngIQOutputImpairmentsPhaseOffset =
{
  /* type        = */RS_VAL_RANGED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */"deg",
  /* rangeValues = */rssgt_rngIQOutputImpairmentsPhaseOffsetEntries
};

static RsRangeTableEntry rssgt_rngPowerServoingTargetLevelEntries[] =
{
  {
    /* discreteOrMinValue = */-120,
    /* maxValue           = */60,
    /* coercedValue       = */0,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerServoingTargetLevel =
{
  /* type        = */RS_VAL_RANGED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerServoingTargetLevelEntries
};

static RsRangeTableEntry rssgt_rngPowerServoingLevelToleranceEntries[] =
{
  {
    /* discreteOrMinValue = */0.01,
    /* maxValue           = */3.0,
    /* coercedValue       = */0,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerServoingLevelTolerance =
{
  /* type        = */RS_VAL_RANGED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerServoingLevelToleranceEntries
};

static RsRangeTableEntry rssgt_rngPowerServoingSensorSelectEntries[] =
{
  {
    /* discreteOrMinValue = */1,
    /* maxValue           = */0,
    /* coercedValue       = */0,
    /* cmdString          = */"SENS1",
    /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */2,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SENS2",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */3,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SENS3",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */4,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"SENS4",
  /* cmdValue           = */0
},
{
  /* discreteOrMinValue = */5,
  /* maxValue           = */0,
  /* coercedValue       = */0,
  /* cmdString          = */"UND",
  /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerServoingSensorSelect =
{
  /* type        = */RS_VAL_DISCRETE,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerServoingSensorSelectEntries
};

static RsRangeTableEntry rssgt_rngPowerServoingApertureEntries[] =
{
  {
    /* discreteOrMinValue = */10.0e-6,
    /* maxValue           = */100.0e-3,
    /* coercedValue       = */0,
    /* cmdString          = */NULL,
    /* cmdValue           = */0
},
RS_RANGE_TABLE_LAST_ENTRY
};

RsRangeTable rssgt_rngPowerServoingAperture =
{
  /* type        = */RS_VAL_RANGED,
  /* hasMin      = */1,
  /* hasMax      = */1,
  /* customInfo  = */NULL,
  /* rangeValues = */rssgt_rngPowerServoingApertureEntries
};


/*****************************************************************************
*- Attributes --------------------------------------------------------------*
 *****************************************************************************/

RsAttrProperties  g_RSSGT_RS_ATTR_RANGE_CHECK =
{
  /* constant           = */RS_ATTR_RANGE_CHECK,

  /* debug name         = */"Range Check",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_QUERY_INSTRUMENT_STATUS =
{
  /* constant           = */RS_ATTR_QUERY_INSTRUMENT_STATUS,

  /* debug name         = */"Query Instrument Status",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CACHE =
{
  /* constant           = */RS_ATTR_CACHE,

  /* debug name         = */"Cache",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SIMULATE =
{
  /* constant           = */RS_ATTR_SIMULATE,

  /* debug name         = */"Simulate",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_RECORD_COERCIONS =
{
  /* constant           = */RS_ATTR_RECORD_COERCIONS,

  /* debug name         = */"Record Value Coercions",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_SUPPORTED | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_INTERCHANGE_CHECK =
{
  /* constant           = */RS_ATTR_INTERCHANGE_CHECK,

  /* debug name         = */"Interchangeability Check",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_SUPPORTED | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPY =
{
  /* constant           = */RS_ATTR_SPY,

  /* debug name         = */"Spy",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_SUPPORTED | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_USE_SPECIFIC_SIMULATION =
{
  /* constant           = */RS_ATTR_USE_SPECIFIC_SIMULATION,

  /* debug name         = */"Use Specific Simulation",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_SUPPORTED | RS_VAL_COERCEABLE_ONLY_BY_INSTR | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_DESCRIPTION =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_DESCRIPTION,

  /* debug name         = */"Class Driver Description",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_PREFIX =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_PREFIX,

  /* debug name         = */"Class Driver Prefix",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_VENDOR =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_VENDOR,

  /* debug name         = */"Class Driver Vendor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_REVISION =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_REVISION,

  /* debug name         = */"Class Driver Revision",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_CLASS_SPEC_MAJOR_VERSION =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_CLASS_SPEC_MAJOR_VERSION,

  /* debug name         = */"Class Driver Major Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_CLASS_SPEC_MINOR_VERSION =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_CLASS_SPEC_MINOR_VERSION,

  /* debug name         = */"Class Driver Minor Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,

  /* debug name         = */"Driver Description",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_PREFIX =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_PREFIX,

  /* debug name         = */"Driver Prefix",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_LOCATOR =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_LOCATOR,

  /* debug name         = */"Driver Locator",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_VENDOR =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_VENDOR,

  /* debug name         = */"Driver Vendor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_REVISION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_REVISION,

  /* debug name         = */"Driver Revision",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,

  /* debug name         = */"Class Specification Major Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,

  /* debug name         = */"Class Specification Minor Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS =
{
  /* constant           = */RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,

  /* debug name         = */"Supported Instrument Models",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_GROUP_CAPABILITIES =
{
  /* constant           = */RS_ATTR_GROUP_CAPABILITIES,

  /* debug name         = */"Class Group Capabilities",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_FUNCTION_CAPABILITIES =
{
  /* constant           = */RS_ATTR_FUNCTION_CAPABILITIES,

  /* debug name         = */"Function Capabilities",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CHANNEL_COUNT =
{
  /* constant           = */RS_ATTR_CHANNEL_COUNT,

  /* debug name         = */"Channel Count",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_DRIVER_SETUP =
{
  /* constant           = */RS_ATTR_DRIVER_SETUP,

  /* debug name         = */"Driver Setup",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_INSTRUMENT_MANUFACTURER =
{
  /* constant           = */RS_ATTR_INSTRUMENT_MANUFACTURER,

  /* debug name         = */"Instrument Manufacturer",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"Rohde&Schwarz",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_INSTRUMENT_MODEL =
{
  /* constant           = */RS_ATTR_INSTRUMENT_MODEL,

  /* debug name         = */"Instrument Model",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION =
{
  /* constant           = */RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,

  /* debug name         = */"Instrument Firmware Revision",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_OPTIONS_LIST =
{
  /* constant           = */RS_ATTR_OPTIONS_LIST,

  /* debug name         = */"Options List",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_IO_RESOURCE_DESCRIPTOR =
{
  /* constant           = */RS_ATTR_IO_RESOURCE_DESCRIPTOR,

  /* debug name         = */"Resource Descriptor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_LOGICAL_NAME =
{
  /* constant           = */RS_ATTR_LOGICAL_NAME,

  /* debug name         = */"Logical Name",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_SUPPORTED | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_PRIMARY_ERROR =
{
  /* constant           = */RS_ATTR_PRIMARY_ERROR,

  /* debug name         = */"Primary Error",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SECONDARY_ERROR =
{
  /* constant           = */RS_ATTR_SECONDARY_ERROR,

  /* debug name         = */"Secondary Error",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_ERROR_ELABORATION =
{
  /* constant           = */RS_ATTR_ERROR_ELABORATION,

  /* debug name         = */"Error Elaboration",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_HIDDEN | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_VISA_RM_SESSION =
{
  /* constant           = */RS_ATTR_VISA_RM_SESSION,

  /* debug name         = */"VISA Resource Manager Session",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_SESSION,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_HIDDEN | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_IO_SESSION =
{
  /* constant           = */RS_ATTR_IO_SESSION,

  /* debug name         = */"Instrument IO Session",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_SESSION,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_IO_SESSION_TYPE =
{
  /* constant           = */RS_ATTR_IO_SESSION_TYPE,

  /* debug name         = */"IO Session Type",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_SUPPORTED | RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,

  /* debug name         = */"Driver Major Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,

  /* debug name         = */"Driver Minor Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION =
{
  /* constant           = */RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,

  /* debug name         = */"Driver Minor Minor Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,

  /* debug name         = */"Class Major Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CLASS_DRIVER_MINOR_VERSION =
{
  /* constant           = */RS_ATTR_CLASS_DRIVER_MINOR_VERSION,

  /* debug name         = */"Class Minor Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_ENGINE_MAJOR_VERSION =
{
  /* constant           = */RS_ATTR_ENGINE_MAJOR_VERSION,

  /* debug name         = */"Engine Major Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_ENGINE_MINOR_VERSION =
{
  /* constant           = */RS_ATTR_ENGINE_MINOR_VERSION,

  /* debug name         = */"Engine Minor Version",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_ENGINE_REVISION =
{
  /* constant           = */RS_ATTR_ENGINE_REVISION,

  /* debug name         = */"Engine Revision",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_OPC_CALLBACK =
{
  /* constant           = */RS_ATTR_OPC_CALLBACK,

  /* debug name         = */"Operation Complete (OPC) Callback",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_ADDR,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_HIDDEN | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_CHECK_STATUS_CALLBACK =
{
  /* constant           = */RS_ATTR_CHECK_STATUS_CALLBACK,

  /* debug name         = */"Check Status Callback",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_ADDR,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_HIDDEN | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_RS_ATTR_OPC_TIMEOUT =
{
  /* constant           = */RS_ATTR_OPC_TIMEOUT,

  /* debug name         = */"Operation Complete (OPC) Timeout",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadOpcTimeout_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteOpcTimeout_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_SOURCE =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_SOURCE,
  /* debug name         = */"ReferenceOscillatorSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngReferenceOscillatorSource,
  /* command            = */":ROSC:SOUR",
  /* integerDefault     = */RSSGT_VAL_ROSC_SOURCE_INTERNAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_EXTERNAL_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_EXTERNAL_FREQUENCY,
  /* debug name         = */"ROSCOutputFrequency",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngROSCOutputFrequency,
  /* command            = */":ROSC:EXT:FREQ",
  /* integerDefault     = */RSSGT_VAL_ROSC_FREQUENCY_100MHZ,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_OUTPUT_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_OUTPUT_FREQUENCY,
  /* debug name         = */"ROSCOutputFrequency",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngROSCOutputFrequency,
  /* command            = */"SOUR:ROSC:OUTP:FREQ",
  /* integerDefault     = */RSSGT_VAL_ROSC_FREQUENCY_10MHZ,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_SYNCHRONIZATION_BANDWIDTH =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_SYNCHRONIZATION_BANDWIDTH,
  /* debug name         = */"ROSCSynchronizationBandwidth",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngROSCSynchronizationBandwidth,
  /* command            = */":ROSC:EXT:SBAN",
  /* integerDefault     = */RSSGT_VAL_ROSC_SBAN_WIDE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_ACTIVE =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_ACTIVE,

  /* debug name         = */"Reference Oscillator Adjustment Active",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":ROSC:ADJ",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_SMALL_SHIFT =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_SMALL_SHIFT,

  /* debug name         = */"Reference Oscillator Adjustment Small Shift",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":ROSC:ADJ:VAL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_CALIBRATION_VALUE =
{
  /* constant           = */RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_CALIBRATION_VALUE,

  /* debug name         = */"Reference Oscillator Adjustment Calibration Value",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:ROSC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BB_SYSTEM_CONFIGURATION =
{
  /* constant           = */RSSGT_ATTR_BB_SYSTEM_CONFIGURATION,
  /* debug name         = */"BBSystemConfiguration",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngBBSystemConfiguration,
  /* command            = */"SCON:MODE",
  /* integerDefault     = */RSSGT_VAL_SYSTEM_CONFIGURATION_STANDARD,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BB_FREQUENCY_OFFSET =
{
  /* constant           = */RSSGT_ATTR_BB_FREQUENCY_OFFSET,

  /* debug name         = */"BB Frequency Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:FOFF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadFrequencyOffset_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteFrequencyOffset_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BB_PATH_GAIN =
{
  /* constant           = */RSSGT_ATTR_BB_PATH_GAIN,

  /* debug name         = */"BB Path Gain",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:PGA",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BB_PHASE_OFFSET =
{
  /* constant           = */RSSGT_ATTR_BB_PHASE_OFFSET,

  /* debug name         = */"BB Phase Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:POFF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadPhaseOffset_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WritePhaseOffset_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BB_PULSE_SEQUENCER_INFO =
{
  /* constant           = */RSSGT_ATTR_BB_PULSE_SEQUENCER_INFO,

  /* debug name         = */"BB Pulse Sequencer Info",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"BB:INFO:PSEQ?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"text",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PATH =
{
  /* constant           = */RSSGT_ATTR_PATH,
  /* debug name         = */"BBPath",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngBBPath,
  /* command            = */NULL,
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ARB_ENABLED,

  /* debug name         = */"ARB Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_WAIT_TO_CONTINUE,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_SET_TO_DEFAULT =
{
  /* constant           = */RSSGT_ATTR_ARB_SET_TO_DEFAULT,

  /* debug name         = */"ARB Set To Default",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:PRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_CLOCK_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_ARB_CLOCK_FREQUENCY,

  /* debug name         = */"ARB Clock Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:CLOC",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0e+6,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_WAVEFORM_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ARB_WAVEFORM_CATALOG,

  /* debug name         = */"ARB Waveform Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"test",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathReadOnlyCollection_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_WAVEFORM_CATALOG_LENGTH =
{
  /* constant           = */RSSGT_ATTR_ARB_WAVEFORM_CATALOG_LENGTH,

  /* debug name         = */"ARB Waveform Catalog Length",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:CAT:LENG?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_WAVEFORM_DELETE =
{
  /* constant           = */RSSGT_ATTR_ARB_WAVEFORM_DELETE,

  /* debug name         = */"ARB Waveform Delete",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"wave1.wv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_WAVEFORM_POINTS =
{
  /* constant           = */RSSGT_ATTR_ARB_WAVEFORM_POINTS,

  /* debug name         = */"ARB Waveform Points",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:POIN?",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_WAVEFORM_SELECT =
{
  /* constant           = */RSSGT_ATTR_ARB_WAVEFORM_SELECT,

  /* debug name         = */"ARB Waveform Select",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:SEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"wave1.wv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_STATUS =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_STATUS,

  /* debug name         = */"ARB Trigger Status",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:RMOD?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"RUN",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_ARM_EXECUTE =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_ARM_EXECUTE,

  /* debug name         = */"ARB Trigger Arm Execute",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:ARM:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXECUTE_TRIGGER =
{
  /* constant           = */RSSGT_ATTR_ARB_EXECUTE_TRIGGER,

  /* debug name         = */"ARB Execute Trigger",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteArbTriggerExecute_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_DELAY_UNIT =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_DELAY_UNIT,
  /* debug name         = */"ARBTriggerDelayUnit",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBTriggerDelayUnit,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:DEL:UNIT",
  /* integerDefault     = */RSSGT_VAL_TRIGGER_DELAY_UNIT_SAMP,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_MODE,
  /* debug name         = */"TrgTriggerMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngTrgTriggerMode,
  /* command            = */"SOUR{Path}:BB:ARB:SEQ",
  /* integerDefault     = */RSSGT_VAL_TRIGGER_MODE_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXTENDED_TRIGGER_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_EXTENDED_TRIGGER_MODE,
  /* debug name         = */"ARBExtendedTriggerMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBExtendedTriggerMode,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:SMOD",
  /* integerDefault     = */RSSGT_VAL_ARB_EXTENDED_TRIGGER_MODE_NEXT,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_SOURCE =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_SOURCE,
  /* debug name         = */"TriggerSour",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngTriggerSour,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:SOUR",
  /* integerDefault     = */RSSGT_VAL_TRIGGER_SOURCE_INTERNAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_SINGLE_SEQUENCE_LENGTH =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_SINGLE_SEQUENCE_LENGTH,

  /* debug name         = */"ARB Trigger Single Sequence Length",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:SLEN",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TRIGGER_SINGLE_SIGNAL_DURATION_UNIT =
{
  /* constant           = */RSSGT_ATTR_ARB_TRIGGER_SINGLE_SIGNAL_DURATION_UNIT,
  /* debug name         = */"ARBSignalDurationUnit",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBSignalDurationUnit,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:SLUN",
  /* integerDefault     = */RSSGT_VAL_ARB_TRIGGER_UNIT_SEQUENCE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXTERNAL_SYNCHRONIZE_OUTPUT =
{
  /* constant           = */RSSGT_ATTR_ARB_EXTERNAL_SYNCHRONIZE_OUTPUT,

  /* debug name         = */"ARB External Synchronize Output",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:SYNC:OUTP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_DELAY =
{
  /* constant           = */RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_DELAY,

  /* debug name         = */"ARB External Trigger Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:EXT{ExternalTrigger}:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_INHIBIT =
{
  /* constant           = */RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_INHIBIT,

  /* debug name         = */"ARB External Trigger Inhibit",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:EXT{ExternalTrigger}:INH",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_TIME_DELAY =
{
  /* constant           = */RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_TIME_DELAY,

  /* debug name         = */"ARB External Trigger Time Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIGger:EXT{ExternalTrigger}:TDEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_TIME_EVENT_DELAY =
{
  /* constant           = */RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_TIME_EVENT_DELAY,

  /* debug name         = */"ARB External Trigger Time Event Delay",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIGger:EXT{ExternalTrigger}:RDEL?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_MODE,
  /* debug name         = */"ARBMarkerMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMarkerMode,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:MODE",
  /* integerDefault     = */RSSGT_VAL_ARB_MARKER_MODE_UNCH,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_PULSE_DIVIDER =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_PULSE_DIVIDER,

  /* debug name         = */"ARB Marker Pulse Divider",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:PULS:DIV",
  /* integerDefault     = */2,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_PULSE_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_PULSE_FREQUENCY,

  /* debug name         = */"ARB Marker Pulse Frequency",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:PULS:FREQ?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_PATTERN =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_PATTERN,

  /* debug name         = */"ARB Marker Pattern",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:PATT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"00000000000000000000000000000010",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_binPattern_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_binPattern_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_ON_TIME =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_ON_TIME,

  /* debug name         = */"ARB Marker ON Time",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:ONT",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_OFF_TIME =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_OFF_TIME,

  /* debug name         = */"ARB Marker OFF Time",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:OFFT",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MARKER_DELAY =
{
  /* constant           = */RSSGT_ATTR_ARB_MARKER_DELAY,

  /* debug name         = */"ARB Marker Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_FIXED_MARKER_DELAY_MAXIMUM =
{
  /* constant           = */RSSGT_ATTR_ARB_FIXED_MARKER_DELAY_MAXIMUM,

  /* debug name         = */"ARB Fixed Marker Delay Maximum",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:DEL:MAX?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_FIXED_MARKER_DELAY_MINIMUM =
{
  /* constant           = */RSSGT_ATTR_ARB_FIXED_MARKER_DELAY_MINIMUM,

  /* debug name         = */"ARB Fixed Marker Delay Minimum",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TRIG:OUTP{Marker}:DEL:MIN?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_CLOCK_SOURCE =
{
  /* constant           = */RSSGT_ATTR_ARB_CLOCK_SOURCE,
  /* debug name         = */"ClockSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngClockSource,
  /* command            = */"SOUR{Path}:BB:ARB:CLOC:SOUR",
  /* integerDefault     = */RSSGT_VAL_CLOCK_SOURCE_INTERNAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_CLOCK_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_CLOCK_MODE,
  /* debug name         = */"ClockMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngClockMode,
  /* command            = */"SOUR{Path}:BB:ARB:CLOC:MODE",
  /* integerDefault     = */RSSGT_VAL_CLOCK_MODE_SAMP,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_CHIP_CLOCK_MULTIPLIER =
{
  /* constant           = */RSSGT_ATTR_ARB_CHIP_CLOCK_MULTIPLIER,

  /* debug name         = */"ARB Chip Clock Multiplier",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:CLOC:MULT",
  /* integerDefault     = */4,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_CLOCK_SYNCHRONISATION_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_CLOCK_SYNCHRONISATION_MODE,
  /* debug name         = */"ClockSynchronisationMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngClockSynchronisationMode,
  /* command            = */"SOUR:BB:ARB:CLOC:SYNC:MODE",
  /* integerDefault     = */RSSGT_VAL_CLOCK_SYNC_MODE_NONE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_SINE_NAME =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_SINE_NAME,

  /* debug name         = */"ARB Tsignal Sine Name",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:SINE:CRE:NAM",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"wave1.wv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_SINE_CREATE =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_SINE_CREATE,

  /* debug name         = */"ARB Tsignal Sine Create",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:SINE:CRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_SINE_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_SINE_FREQUENCY,

  /* debug name         = */"ARB Tsignal Sine Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:SINE:FREQ",
  /* integerDefault     = */0,
  /* doubleDefault      = */1000.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_SINE_PHASE =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_SINE_PHASE,

  /* debug name         = */"ARB Tsignal Sine Phase",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:SINE:PHAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */90.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_SINE_SAMPLES =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_SINE_SAMPLES,

  /* debug name         = */"ARB Tsignal Sine Samples",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:SINE:SAMP",
  /* integerDefault     = */100,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_NAME =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_NAME,

  /* debug name         = */"ARB Tsignal Rectangle Name",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:RECT:CRE:NAM",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"wave1.wv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_CREATE =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_CREATE,

  /* debug name         = */"ARB Tsignal Rectangle Create",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:RECT:CRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_FREQUENCY,

  /* debug name         = */"ARB Tsignal Rectangle Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:RECT:FREQ",
  /* integerDefault     = */0,
  /* doubleDefault      = */1000.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_AMPLITUDE =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_AMPLITUDE,

  /* debug name         = */"ARB Tsignal Rectangle Amplitude",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:RECT:AMPL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.800,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_OFFSET_DC =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_OFFSET_DC,

  /* debug name         = */"ARB Tsignal Rectangle Offset DC",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:RECT:OFFS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_SAMPLES =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_SAMPLES,

  /* debug name         = */"ARB Tsignal Rectangle Samples",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:RECT:SAMP",
  /* integerDefault     = */100,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_NAME =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_CIQ_NAME,

  /* debug name         = */"ARB Tsignal CIQ Name",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:CIQ:CRE:NAM",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"wave1.wv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_CREATE =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_CIQ_CREATE,

  /* debug name         = */"ARB Tsignal CIQ Create",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:CIQ:CRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_I =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_CIQ_I,

  /* debug name         = */"ARB Tsignal CIQ I",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:CIQ:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_Q =
{
  /* constant           = */RSSGT_ATTR_ARB_TSIGNAL_CIQ_Q,

  /* debug name         = */"ARB Tsignal CIQ Q",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:TSIG:CIQ:Q",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_STREAMING_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_STREAMING_ENABLED,

  /* debug name         = */"ARB Multisegment Streaming Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:HDDS:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_FREE_DISK_SPACE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_FREE_DISK_SPACE,

  /* debug name         = */"ARB Multisegment Free Disk Space",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:FREE?",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_FILLING_LEVEL_STREAMING_BUFFER =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_FILLING_LEVEL_STREAMING_BUFFER,

  /* debug name         = */"ARB Multisegment Filling Level Streaming Buffer",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WAV:HDDS:BLEV?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_OUTPUT_SEGMENT =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_OUTPUT_SEGMENT,

  /* debug name         = */"ARB Multisegment Output Segment",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:NEXT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadArbNextSegment_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteArbNextSegment_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_CURRENT_OUTPUT_SEGMENT =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_CURRENT_OUTPUT_SEGMENT,

  /* debug name         = */"ARB Multisegment Current Output Segment",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_LEVEL_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_LEVEL_MODE,
  /* debug name         = */"ARBMultisegmentLevelMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMultisegmentLevelMode,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:LEV",
  /* integerDefault     = */RSSGT_VAL_ARB_LEVEL_MODE_UNCH,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_MARKER_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_MARKER_MODE,
  /* debug name         = */"ARBMultisegmentMarkerMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMultisegmentMarkerMode,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:MARK:MODE",
  /* integerDefault     = */RSSGT_VAL_ARB_MULTI_MARKER_MODE_TAKE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_SEQUENCE_RESTART =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_SEQUENCE_RESTART,
  /* debug name         = */"ARBSequenceRestart",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBSequenceRestart,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:MARK:FSEG",
  /* integerDefault     = */RSSGT_VAL_ARB_SRESTART_DISABLED,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_SEGMENT_RESTART =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_SEGMENT_RESTART,
  /* debug name         = */"ARBSequenceRestart",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBSequenceRestart,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:MARK:ESEG",
  /* integerDefault     = */RSSGT_VAL_ARB_SRESTART_DISABLED,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_SAVE_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_SAVE_FILE,

  /* debug name         = */"ARB Multisegment Save File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:OFIL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_APPEND_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_APPEND_FILE,

  /* debug name         = */"ARB Multisegment Append File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:SEGM:APP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"arb1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_NAME =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_NAME,

  /* debug name         = */"ARB Multisegment Name",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:NAME?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"seg1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDoubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_LEVEL =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_LEVEL,
  /* debug name         = */"ARBMultisegmentLevel",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMultisegmentLevel,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:LMOD",
  /* integerDefault     = */RSSGT_VAL_ARB_LEVEL_MODE_HIGHEST,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_EXECUTE_NEXT_SEGMENT =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_EXECUTE_NEXT_SEGMENT,

  /* debug name         = */"ARB Multisegment Execute Next Segment",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:NEXT:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteArbNextSegmentExecute_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_NEXT_SEGMENT_SOURCE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_NEXT_SEGMENT_SOURCE,
  /* debug name         = */"TriggerNextSour",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngTriggerNextSour,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:NEXT:SOUR",
  /* integerDefault     = */RSSGT_VAL_TRIGGER_SOURCE_INTERNAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_SEQUENCING_LIST =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_SEQUENCING_LIST,

  /* debug name         = */"ARB Multisegment Sequencing List",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:SEQ:SEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"play_list_1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDoubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDoubleQuotedString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_CONFIGURATION_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_CONFIGURATION_FILE,

  /* debug name         = */"ARB Multisegment Configuration File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:SEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"new",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_CREATE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_CREATE,

  /* debug name         = */"ARB Multisegment Create",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"new",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_LOAD_FROM_CONFIGURATION_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_LOAD_FROM_CONFIGURATION_FILE,

  /* debug name         = */"ARB Multisegment Load From Configuration File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CLO",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"new",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_CATALOG,

  /* debug name         = */"ARB Multisegment Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathReadOnlyCollection_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_SEGMENT_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_SEGMENT_CATALOG,

  /* debug name         = */"ARB Multisegment Segment Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:SEGM:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathReadOnlyCollection_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_DELETE_CONFIGURATION_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_DELETE_CONFIGURATION_FILE,

  /* debug name         = */"ARB Multisegment Delete Configuration File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_COMMENT =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_COMMENT,

  /* debug name         = */"ARB Multisegment Comment",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:COMM",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"comment",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDoubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDoubleQuotedString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_CLOCK =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_CLOCK,

  /* debug name         = */"ARB Multisegment Clock",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:CLOC",
  /* integerDefault     = */0,
  /* doubleDefault      = */10.0e6,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTISEGMENT_CLOCK_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTISEGMENT_CLOCK_MODE,
  /* debug name         = */"ARBMultisegmentClockMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMultisegmentClockMode,
  /* command            = */"SOUR{Path}:BB:ARB:WSEG:CONF:CLOC:MODE",
  /* integerDefault     = */RSSGT_VAL_ARB_CLOCK_MODE_UNCH,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CREATE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CREATE,

  /* debug name         = */"ARB Multi Carrier Create",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLOCK =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CLOCK,

  /* debug name         = */"ARB Multi Carrier Clock",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CLOC?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_RESET =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_RESET,

  /* debug name         = */"ARB Multi Carrier Reset",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:PRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_MODE,
  /* debug name         = */"ARBMultiCarrierMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMultiCarrierMode,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR:MODE",
  /* integerDefault     = */RSSGT_VAL_ARB_MULTIC_MODE_EQU,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CREST_FACTOR_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CREST_FACTOR_MODE,
  /* debug name         = */"ARBMultiCarrierCrestFactorMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMultiCarrierCrestFactorMode,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CFAC:MODE",
  /* integerDefault     = */RSSGT_VAL_ARB_SRC_CFACTOR_MODE_OFF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_OUTPUT_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_OUTPUT_FILE,

  /* debug name         = */"ARB Multi Carrier Output File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:OFIL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_SAVE_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_SAVE_FILE,

  /* debug name         = */"ARB Multi Carrier Save File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CLO",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_SAMPLES =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_SAMPLES,

  /* debug name         = */"ARB Multi Carrier Samples",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:SAMP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_SIGNAL_PERIOD_MODE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_SIGNAL_PERIOD_MODE,
  /* debug name         = */"ARBSignalPeriodMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBSignalPeriodMode,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:TIME:MODE",
  /* integerDefault     = */RSSGT_VAL_ARB_SRC_CALC_MODE_LONG,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_SIGNAL_PERIOD =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_SIGNAL_PERIOD,

  /* debug name         = */"ARB Multi Carrier Signal Period",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:TIME",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_POWER_REFERENCE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_POWER_REFERENCE,
  /* debug name         = */"ARBMCarPowerRef",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngARBMCarPowerRef,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:POW:REF",
  /* integerDefault     = */RSSGT_VAL_ARB_MCAR_POWER_REF_RMS,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_COUNT =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_COUNT,

  /* debug name         = */"ARB Multi Carrier Count",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR:COUN",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_SPACING =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_SPACING,

  /* debug name         = */"ARB Multi Carrier Spacing",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR:SPAC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_FREQUENCY,

  /* debug name         = */"ARB Multi Carrier Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:FREQ",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_DELAY =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_DELAY,

  /* debug name         = */"ARB Multi Carrier Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_DATA_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_DATA_FILE,

  /* debug name         = */"ARB Multi Carrier Data File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:FILE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"test",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDoubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDoubleQuotedString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_PHASE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_PHASE,

  /* debug name         = */"ARB Multi Carrier Phase",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:PHAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_POWER =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_POWER,

  /* debug name         = */"ARB Multi Carrier Power",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:POW",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_ENABLED,

  /* debug name         = */"ARB Multi Carrier Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CONFLICT =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CONFLICT,

  /* debug name         = */"ARB Multi Carrier Conflict",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CARR{ARBCarrier}:CONF?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_EXECUTE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_EXECUTE,

  /* debug name         = */"ARB Multi Carrier Edit Execute",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathEvent_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_DELAY =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_DELAY,

  /* debug name         = */"ARB Multi Carrier Edit Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_DELAY_STEP =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_DELAY_STEP,

  /* debug name         = */"ARB Multi Carrier Edit Delay Step",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:DEL:STEP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_INPUT_IQ_FILE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_INPUT_IQ_FILE,

  /* debug name         = */"ARB Multi Carrier Edit Input IQ File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:FILE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDoubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDoubleQuotedString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_PHASE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_PHASE,

  /* debug name         = */"ARB Multi Carrier Edit Phase",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:PHAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_PHASE_STEP =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_PHASE_STEP,

  /* debug name         = */"ARB Multi Carrier Edit Phase Step",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:PHAS:STEP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_POWER =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_POWER,

  /* debug name         = */"ARB Multi Carrier Edit Power",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:POW",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_POWER_STEP =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_POWER_STEP,

  /* debug name         = */"ARB Multi Carrier Edit Power Step",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:POW:STEP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_START =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_START,

  /* debug name         = */"ARB Multi Carrier Edit Start",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:STAR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_STOP =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_STOP,

  /* debug name         = */"ARB Multi Carrier Edit Stop",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:STOP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathInt32_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathInt32_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_ENABLED,

  /* debug name         = */"ARB Multi Carrier Edit Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:EDIT:CARR:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_STORE_FAST =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_STORE_FAST,

  /* debug name         = */"ARB Multi Carrier File Store Fast",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:SETT:STOR:FAST",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_CATALOG,

  /* debug name         = */"ARB Multi Carrier File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:SETT:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathReadOnlyCollection_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_LOAD =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_LOAD,

  /* debug name         = */"ARB Multi Carrier File Load",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:SETT:LOAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_STORE =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_STORE,

  /* debug name         = */"ARB Multi Carrier File Store",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:SETT:STOR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDoubleQuotedString_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_ENABLED,

  /* debug name         = */"ARB Multi Carrier Clipping Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CLIP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathBool_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathBool_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_TARGET_CREST_FACTOR =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_TARGET_CREST_FACTOR,

  /* debug name         = */"ARB Multi Carrier Clipping Target Crest Factor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CLIP:CFAC",
  /* integerDefault     = */0,
  /* doubleDefault      = */50.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_FILTER_CUT_OFF_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_FILTER_CUT_OFF_FREQUENCY,

  /* debug name         = */"ARB Multi Carrier Clipping Filter Cut Off Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR{Path}:BB:ARB:MCAR:CLIP:CUT",
  /* integerDefault     = */0,
  /* doubleDefault      = */50.0e+6,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_PathDbl_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_PathDbl_WriteCallback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_PROGRESS_MULTI_CODER =
{
  /* constant           = */RSSGT_ATTR_PROGRESS_MULTI_CODER,

  /* debug name         = */"Progress Multi Coder",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":BB:PROG:MCOD?",
  /* integerDefault     = */100,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PROGRESS_MULTI_CARRIER =
{
  /* constant           = */RSSGT_ATTR_PROGRESS_MULTI_CARRIER,

  /* debug name         = */"Progress Multi Carrier",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":BB:PROG:MCOD:ARB:MCAR?",
  /* integerDefault     = */100,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PROGRESS_MULTI_SEGMENT =
{
  /* constant           = */RSSGT_ATTR_PROGRESS_MULTI_SEGMENT,

  /* debug name         = */"Progress Multi Segment",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":BB:PROG:MCOD:ARB:WSEG?",
  /* integerDefault     = */100,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_ENABLED,

  /* debug name         = */"IQ Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadModState_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteModState_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_WIDEBAND_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_WIDEBAND_ENABLED,

  /* debug name         = */"IQ Wideband Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:WBST",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadIqWidebandState_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteIqWidebandState_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_ANALOG_WIDEBAND_CREST_FACTOR =
{
  /* constant           = */RSSGT_ATTR_IQ_ANALOG_WIDEBAND_CREST_FACTOR,

  /* debug name         = */"IQ Analog Wideband Crest Factor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:CRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_LEVEL_ENTRY =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_LEVEL_ENTRY,
  /* debug name         = */"IQOutputLevelEntry",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngIQOutputLevelEntry,
  /* command            = */":IQ:OUTP:POW:VIA",
  /* integerDefault     = */RSSGT_VAL_IQ_OUTPUT_LEVEL_ENTRY_PEP,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_DIGITAL_OVERFLOW_RESET =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_DIGITAL_OVERFLOW_RESET,

  /* debug name         = */"IQ Output Digital Overflow Reset",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:OUTP:DIG:OFL:HOLD:RES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_ENABLED,

  /* debug name         = */"IQ Output Analog Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ANAL:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_SET_TO_DEFAULT =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_SET_TO_DEFAULT,

  /* debug name         = */"IQ Output Analog Set To Default",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:PRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_TYPE =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_TYPE,
  /* debug name         = */"IQOutputAnalogType",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngIQOutputAnalogType,
  /* command            = */"SOUR:IQ:OUTP:TYPE",
  /* integerDefault     = */RSSGT_VAL_IQ_OUTPUT_ANALOG_TYPE_SINGLE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_LOAD_SETTINGS =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_LOAD_SETTINGS,

  /* debug name         = */"IQ Output Analog Load Settings",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:SETT:LOAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iqout",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_STORE_SETTINGS =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_STORE_SETTINGS,

  /* debug name         = */"IQ Output Analog Store Settings",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:SETT:STOR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iqout",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_DELETE_SETTINGS =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_DELETE_SETTINGS,

  /* debug name         = */"IQ Output Analog Delete Settings",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:SETT:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iqout",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_SETTINGS_CATALOG =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_SETTINGS_CATALOG,

  /* debug name         = */"IQ Output Analog Settings Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:SETT:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iqout",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_I_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_I_OFFSET,

  /* debug name         = */"IQ Output Analog I Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:OFFS:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_Q_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_Q_OFFSET,

  /* debug name         = */"IQ Output Analog Q Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:OFFS:Q",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_DISPLAY_POWER_VIA =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_DISPLAY_POWER_VIA,
  /* debug name         = */"IQOutputAnalogDisplayPowerVia",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngIQOutputAnalogDisplayPowerVia,
  /* command            = */"SOUR:IQ:OUTP:POW:VIA",
  /* integerDefault     = */RSSGT_VAL_DISPLAY_VIA_PEP,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_RF_ENVELOPE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_RF_ENVELOPE,

  /* debug name         = */"Envelope Tracking RF Envelope",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VOLTAGE_ADAPTATION =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VOLTAGE_ADAPTATION,
  /* debug name         = */"EnvelopeTrackingVoltageAdaptation",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingVoltageAdaptation,
  /* command            = */"SOUR:IQ:OUTP:ENV:ADAP",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_VOLTAGE_ADAPTATION_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_ETRACK_INTERFACE_TYPE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_ETRACK_INTERFACE_TYPE,
  /* debug name         = */"EnvelopeTrackingeTrackInterfaceType",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingeTrackInterfaceType,
  /* command            = */"SOUR:IQ:OUTP:ENV:ETR",
  /* integerDefault     = */RSSGT_VAL_ETRACK_INTERFACE_TYPE_USER,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VOLTAGE_REFERENCE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VOLTAGE_REFERENCE,
  /* debug name         = */"EnvelopeTrackingVoltageReference",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingVoltageReference,
  /* command            = */"SOUR:IQ:OUTP:ENV:VREF",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_VOLTAGE_REFERENCE_VCC,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VOUT_MAX =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VOUT_MAX,

  /* debug name         = */"Envelope Tracking Vout Max",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:VOUT:MAX",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VOUT_MIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VOUT_MIN,

  /* debug name         = */"Envelope Tracking Vout Min",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:VOUT:MIN",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_BIAS =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_BIAS,

  /* debug name         = */"Envelope Tracking Bias",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:BIAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_OFFSET =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_OFFSET,

  /* debug name         = */"Envelope Tracking Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:OFFS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VPP_MAX =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VPP_MAX,

  /* debug name         = */"Envelope Tracking Vpp Max",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:VPP",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_EMF_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_EMF_ENABLED,

  /* debug name         = */"Envelope Tracking EMF Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:EMF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_RIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_RIN,

  /* debug name         = */"Envelope Tracking Rin",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:RIN",
  /* integerDefault     = */0,
  /* doubleDefault      = */50.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_TERMINATION =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_TERMINATION,
  /* debug name         = */"EnvelopeTrackingTermination",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingTermination,
  /* command            = */"SOUR:IQ:OUTP:ENV:TERM",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_TRACKING_TERMINATION_GROUND,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_BIPOLAR_INPUT_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_BIPOLAR_INPUT_ENABLED,

  /* debug name         = */"Envelope Tracking Bipolar Input Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:BINP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_GAIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_GAIN,

  /* debug name         = */"Envelope Tracking Gain",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:GAIN",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VCC_OFFSET =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VCC_OFFSET,

  /* debug name         = */"Envelope Tracking Vcc Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:VCC:OFFS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VCC_MAX =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VCC_MAX,

  /* debug name         = */"Envelope Tracking Vcc Max",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:VCC:MAX",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_VCC_MIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_VCC_MIN,

  /* debug name         = */"Envelope Tracking Vcc Min",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:VCC:MIN",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_PEP_IN_MAX =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_PEP_IN_MAX,

  /* debug name         = */"Envelope Tracking PEPin Max",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:PIN:MAX",
  /* integerDefault     = */0,
  /* doubleDefault      = */-20.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_PEP_IN_MIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_PEP_IN_MIN,

  /* debug name         = */"Envelope Tracking PEPin Min",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:PIN:MIN",
  /* integerDefault     = */0,
  /* doubleDefault      = */-30.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_POWER_OFFSET =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_POWER_OFFSET,

  /* debug name         = */"Envelope Tracking Power Offset",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:POW:OFFS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_DELAY =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_DELAY,

  /* debug name         = */"Envelope Tracking Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_CALCULATE_ENVELOPE_FROM_PREDISTORTED_SIGNAL =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_CALCULATE_ENVELOPE_FROM_PREDISTORTED_SIGNAL,

  /* debug name         = */"Envelope Tracking Calculate Envelope from Predistorted Signal",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:FDPD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING,
  /* debug name         = */"EnvelopeTrackingShaping",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingShaping,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:MODE",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_SHAPING_OFF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_FUNCTION =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_FUNCTION,
  /* debug name         = */"EnvelopeTrackingDetroughingFunction",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingDetroughingFunction,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:DETR:FUNC",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_DETROUGHING_FUNCTION_F1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_COUPLE_DETROUGHING_FACTOR_WITH_VCC =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_COUPLE_DETROUGHING_FACTOR_WITH_VCC,

  /* debug name         = */"Envelope Tracking Shaping Couple Detroughing Factor with Vcc",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:DETR:COUP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_FACTOR =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_FACTOR,

  /* debug name         = */"Envelope Tracking Shaping Detroughing Factor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:DETR:FACT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.2,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_EXPONENT =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_EXPONENT,

  /* debug name         = */"Envelope Tracking Shaping Detroughing Exponent",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:DETR:PEXP",
  /* integerDefault     = */0,
  /* doubleDefault      = */2.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PRE_GAIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PRE_GAIN,

  /* debug name         = */"Envelope Tracking Shaping Pre Gain",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:GAIN:PRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POST_GAIN =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POST_GAIN,

  /* debug name         = */"Envelope Tracking Shaping Post Gain",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:GAIN:POST",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_INTERPOLATION =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_INTERPOLATION,
  /* debug name         = */"EnvelopeTrackingShapingInterpolation",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEnvelopeTrackingShapingInterpolation,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:INT",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_SHAPING_INTERPOLATION_OFF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_SCALE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_SCALE,
  /* debug name         = */"EvenlopeTrackingShapingScale",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngEvenlopeTrackingShapingScale,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:SCAL",
  /* integerDefault     = */RSSGT_VAL_ENVELOPE_SHAPING_SCALE_VOLTAGE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_CLIPPING_FROM =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_CLIPPING_FROM,

  /* debug name         = */"Envelope Tracking Shaping Clipping From",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:CLIP:FROM",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_CLIPPING_TO =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_CLIPPING_TO,

  /* debug name         = */"Envelope Tracking Shaping Clipping To",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:CLIP:TO",
  /* integerDefault     = */100,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_FILE_CATALOG,

  /* debug name         = */"Envelope Tracking Shaping File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:FILE:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_lut",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_SELECT_FILE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_SELECT_FILE,

  /* debug name         = */"Envelope Tracking Shaping Select File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:FILE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_lut",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PV_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PV_FILE_CATALOG,

  /* debug name         = */"Envelope Tracking Shaping PV File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:PV:FILE:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_lutpv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PV_SELECT_FILE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PV_SELECT_FILE,

  /* debug name         = */"Envelope Tracking Shaping PV Select File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:PV:FILE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_lutpv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_FILE_CATALOG,

  /* debug name         = */"Envelope Tracking Shaping Polynomial File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:COEF:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_poly",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_LOAD_FILE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_LOAD_FILE,

  /* debug name         = */"Envelope Tracking Shaping Polynomial Load File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:COEF:LOAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_poly",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_SAVE_FILE =
{
  /* constant           = */RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_SAVE_FILE,

  /* debug name         = */"Envelope Tracking Shaping Polynomial Save File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:ENV:SHAP:COEF:STOR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.iq_poly",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_MODULATION_IMPAIRMENTS_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_MODULATION_IMPAIRMENTS_ENABLED,

  /* debug name         = */"IQ Modulation Impairments Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:IMP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_I_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_I_OFFSET,

  /* debug name         = */"IQ I-Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:IMP:LEAK:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.00,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_Q_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_Q_OFFSET,

  /* debug name         = */"IQ Q-Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:IMP:LEAK:Q",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_GAIN_IMBALANCE =
{
  /* constant           = */RSSGT_ATTR_IQ_GAIN_IMBALANCE,

  /* debug name         = */"IQ Gain Imbalance",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:IMP:IQR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_QUADRATURE_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_QUADRATURE_OFFSET,

  /* debug name         = */"IQ Quadrature Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:IMP:QUAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_SOURCE =
{
  /* constant           = */RSSGT_ATTR_IQ_SOURCE,
  /* debug name         = */"IQSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngIQSource,
  /* command            = */":IQ:SOUR",
  /* integerDefault     = */RSSGT_VAL_IQ_SOURCE_BASEBAND,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_SWAP =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_SWAP,

  /* debug name         = */"IQ Impairments Swap",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":IQ:IMP:SWAP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_ENABLED =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_ENABLED,

  /* debug name         = */"Digital Predistortion Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SET_TO_DEFAULT =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SET_TO_DEFAULT,

  /* debug name         = */"Digital Predistortion Set To Default",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:PRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_LOAD_SETTINGS =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_LOAD_SETTINGS,

  /* debug name         = */"Digital Predistortion Load Settings",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SETT:LOAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_STORE_SETTINGS =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_STORE_SETTINGS,

  /* debug name         = */"Digital Predistortion Store Settings",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SETT:STOR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_DELETE_SETTINGS =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_DELETE_SETTINGS,

  /* debug name         = */"Digital Predistortion Delete Settings",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SETT:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SETTINGS_CATALOG =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SETTINGS_CATALOG,

  /* debug name         = */"Digital Predistortion Settings Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SETT:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_AM_FIRST =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_AM_FIRST,

  /* debug name         = */"Digital Predistortion AM/AM First",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:AMF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_LEVEL_REFERENCE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_LEVEL_REFERENCE,
  /* debug name         = */"DigitalPredistortionLevelReference",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngDigitalPredistortionLevelReference,
  /* command            = */"SOUR:IQ:DPD:LREF",
  /* integerDefault     = */RSSGT_VAL_DPD_LEVEL_REFERENCE_BDPD,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_OUTPUT_LEVEL_ERROR =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_OUTPUT_LEVEL_ERROR,

  /* debug name         = */"Digital Predistortion Maximum Output Level Error",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:OUTP:ERR:MAX",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.1,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_NUMBER_OF_ITERACTIONS =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_NUMBER_OF_ITERACTIONS,

  /* debug name         = */"Digital Predistortion Maximum Number of Iteractions",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:OUTP:ITER:MAX",
  /* integerDefault     = */3,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INTERACTIONS_STATUS =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_INTERACTIONS_STATUS,

  /* debug name         = */"Digital Predistortion Interactions Status",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:MEAS:STAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_ACHIEVED_OUTPUT_LEVEL_ERROR =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_ACHIEVED_OUTPUT_LEVEL_ERROR,

  /* debug name         = */"Digital Predistortion Achieved Output Level Error",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:OUTP:ERR?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_PEP =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_PEP,

  /* debug name         = */"Digital Predistortion Input PEP",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:INP:PEP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_LEVEL =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_LEVEL,

  /* debug name         = */"Digital Predistortion Input Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:INP:LEV?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_CREST_FACTOR =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_CREST_FACTOR,

  /* debug name         = */"Digital Predistortion Input Crest Factor",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:INP:CFAC?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_PEP =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_PEP,

  /* debug name         = */"Digital Predistortion Output PEP",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:OUTP:PEP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_LEVEL =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_LEVEL,

  /* debug name         = */"Digital Predistortion Output Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:OUTP:LEV?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_CREST_FACTOR =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_CREST_FACTOR,

  /* debug name         = */"Digital Predistortion Output Crest Factor",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:OUTP:CFAC?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_AM_STATE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_AM_STATE,

  /* debug name         = */"Digital Predistortion AM/AM State",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:AMAM:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_PM_STATE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_PM_STATE,

  /* debug name         = */"Digital Predistortion AM/PM State",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:AMPM:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING,
  /* debug name         = */"DigitalPredistortionShaping",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngDigitalPredistortionShaping,
  /* command            = */"SOUR:IQ:DPD:SHAP:MODE",
  /* integerDefault     = */RSSGT_VAL_DPD_SHAPING_TABLE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INTERPOLATION =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_INTERPOLATION,
  /* debug name         = */"DigitalPredistortionInterpolation",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngDigitalPredistortionInterpolation,
  /* command            = */"SOUR:IQ:DPD:SHAP:TABL:INT",
  /* integerDefault     = */RSSGT_VAL_DPD_INTERPOLATION_OFF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INVERT_CORRECTION_VALUES =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_INVERT_CORRECTION_VALUES,

  /* debug name         = */"Digital Predistortion Invert Correction Values",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:INV",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_PEP_INPUT_POWER =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_PEP_INPUT_POWER,

  /* debug name         = */"Digital Predistortion Maximum PEP Input Power",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:PIN:MAX",
  /* integerDefault     = */0,
  /* doubleDefault      = */10.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MINIMUM_PEP_INPUT_POWER =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_MINIMUM_PEP_INPUT_POWER,

  /* debug name         = */"Digital Predistortion Minimum PEP Input Power",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:PIN:MIN",
  /* integerDefault     = */0,
  /* doubleDefault      = */10.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_PRE_GAIN =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_PRE_GAIN,

  /* debug name         = */"Digital Predistortion Pre Gain",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:GAIN:PRE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_AM_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_AM_FILE_CATALOG,

  /* debug name         = */"Digital Predistortion Shaping Table AM/AM File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:TABL:AMAM:FILE:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_magn",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_AM_SELECT_FILE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_AM_SELECT_FILE,

  /* debug name         = */"Digital Predistortion Shaping Table AM/AM Select File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:TABL:AMAM:FILE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_magn",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_PM_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_PM_FILE_CATALOG,

  /* debug name         = */"Digital Predistortion Shaping Table AM/PM File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:TABL:AMPM:FILE:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_phase",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_PM_SELECT_FILE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_PM_SELECT_FILE,

  /* debug name         = */"Digital Predistortion Shaping Table AM/PM Select File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:TABL:AMPM:FILE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_phase",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_FILE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_FILE_CATALOG,

  /* debug name         = */"Digital Predistortion Shaping Polynomial File Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:POLY:COEF:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_poly",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_LOAD_FILE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_LOAD_FILE,

  /* debug name         = */"Digital Predistortion Shaping Polynomial Load File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:POLY:COEF:LOAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_poly",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_SAVE_FILE =
{
  /* constant           = */RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_SAVE_FILE,

  /* debug name         = */"Digital Predistortion Shaping Polynomial Save File",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:DPD:SHAP:POLY:COEF:STOR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file.dpd_poly",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_ENABLED,

  /* debug name         = */"IQ Impairments Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_DELAY =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_DELAY,

  /* debug name         = */"IQ Impairments Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_RATIO =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_RATIO,

  /* debug name         = */"IQ Impairments Ratio",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:IQR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_LEAKAGE_I =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_LEAKAGE_I,

  /* debug name         = */"IQ Impairments Leakage I",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:LEAK:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_LEAKAGE_Q =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_LEAKAGE_Q,

  /* debug name         = */"IQ Impairments Leakage Q",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:LEAK:Q",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_QUADRATURE_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_QUADRATURE_OFFSET,

  /* debug name         = */"IQ Impairments Quadrature Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:QUAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_SKEW =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_SKEW,

  /* debug name         = */"IQ Impairments Skew",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:SKEW",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_PEAK_LEVEL =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_PEAK_LEVEL,

  /* debug name         = */"IQ Impairments Peak Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:POW:PEAK?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_SIGNAL_LEVEL =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_SIGNAL_LEVEL,

  /* debug name         = */"IQ Impairments Signal Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:POW:RMS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_OPTIMIZATION_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_OPTIMIZATION_ENABLED,

  /* debug name         = */"IQ Impairments Optimization Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:OPT:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_OPTIMIZATION_MODE =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_OPTIMIZATION_MODE,
  /* debug name         = */"IMPOptimizationMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngIMPOptimizationMode,
  /* command            = */":BB:IMP:OPT:MODE",
  /* integerDefault     = */RSSGT_VAL_OPTIM_MODE_FAST,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_IMPAIRMENTS_CREST_FACTOR =
{
  /* constant           = */RSSGT_ATTR_IQ_IMPAIRMENTS_CREST_FACTOR,

  /* debug name         = */"IQ Impairments Crest Factor",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:CFAC?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_ENABLED =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_ENABLED,

  /* debug name         = */"IQ Output Impairments Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"BB:IMP:IQO{IQOutput}:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_DELAY =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_DELAY,

  /* debug name         = */"IQ Output Impairments Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"BB:IMP:IQO{IQOutput}:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_RATIO =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_RATIO,

  /* debug name         = */"IQ Output Impairments Ratio",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"BB:IMP:IQO{IQOutput}:IQR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_LEAKAGE_I =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_LEAKAGE_I,

  /* debug name         = */"IQ Output Impairments Leakage I",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:IQO{IQOutput}:LEAK:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_LEAKAGE_Q =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_LEAKAGE_Q,

  /* debug name         = */"IQ Output Impairments Leakage Q",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:IQO{IQOutput}:LEAK:Q",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_QUADRATURE_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_QUADRATURE_OFFSET,

  /* debug name         = */"IQ Output Impairments Quadrature Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:IQO{IQOutput}:QUAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_SKEW =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_SKEW,

  /* debug name         = */"IQ Output Impairments Skew",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BB:IMP:IQO{IQOutput}:SKEW",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_PHASE_OFFSET =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_PHASE_OFFSET,

  /* debug name         = */"IQ Output Impairments Phase Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */&rssgt_rngIQOutputImpairmentsPhaseOffset,
  /* command            = */":BB:IMP:IQO{IQOutput}:POFF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_ENABLED =
{
  /* constant           = */RSSGT_ATTR_AWGN_ENABLED,

  /* debug name         = */"AWGN Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_MODE =
{
  /* constant           = */RSSGT_ATTR_AWGN_MODE,
  /* debug name         = */"AWGNMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngAWGNMode,
  /* command            = */":AWGN:MODE",
  /* integerDefault     = */RSSGT_VAL_AWGN_MODE_ADD,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_BANDWIDTH =
{
  /* constant           = */RSSGT_ATTR_AWGN_BANDWIDTH,

  /* debug name         = */"AWGN Bandwidth",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:BWID",
  /* integerDefault     = */0,
  /* doubleDefault      = */3.84e+6,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_BANDWIDTH_RATIO =
{
  /* constant           = */RSSGT_ATTR_AWGN_BANDWIDTH_RATIO,

  /* debug name         = */"AWGN Bandwidth Ratio",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:BWID:RAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_BANDWIDTH_NOISE =
{
  /* constant           = */RSSGT_ATTR_AWGN_BANDWIDTH_NOISE,

  /* debug name         = */"AWGN Bandwidth Noise",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:BWID:NOIS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_BIT_RATE =
{
  /* constant           = */RSSGT_ATTR_AWGN_BIT_RATE,

  /* debug name         = */"AWGN Bit Rate",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:BRAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */100000.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_DISPLAY_MODE =
{
  /* constant           = */RSSGT_ATTR_AWGN_DISPLAY_MODE,
  /* debug name         = */"AWGNDisplayMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngAWGNDisplayMode,
  /* command            = */":AWGN:DISP:MODE",
  /* integerDefault     = */RSSGT_VAL_AWGN_DISP_MODE_RF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_DISPLAY_OUTPUT_RESULT =
{
  /* constant           = */RSSGT_ATTR_AWGN_DISPLAY_OUTPUT_RESULT,
  /* debug name         = */"BBINMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngBBINMode,
  /* command            = */":AWGN:DISP:ORES",
  /* integerDefault     = */RSSGT_VAL_BBIN_MODE_ANALOG,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_TARGET_CW_FREQUENCY_OFFSET =
{
  /* constant           = */RSSGT_ATTR_AWGN_TARGET_CW_FREQUENCY_OFFSET,

  /* debug name         = */"AWGN Target CW Frequency Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:FREQ:TARG",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_RESULTING_CW_FREQUENCY_OFFSET =
{
  /* constant           = */RSSGT_ATTR_AWGN_RESULTING_CW_FREQUENCY_OFFSET,

  /* debug name         = */"AWGN Resulting CW Frequency Offset",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:FREQ:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_NOISE_LEVEL_VIA =
{
  /* constant           = */RSSGT_ATTR_AWGN_NOISE_LEVEL_VIA,
  /* debug name         = */"AWGNNoiseMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngAWGNNoiseMode,
  /* command            = */":AWGN:POW:MODE",
  /* integerDefault     = */RSSGT_VAL_AWGN_POWER_MODE_CN,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_CARRIER_TO_NOISE_RATIO =
{
  /* constant           = */RSSGT_ATTR_AWGN_CARRIER_TO_NOISE_RATIO,

  /* debug name         = */"AWGN Carrier To Noise Ratio",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:CNR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_EB_TO_N0 =
{
  /* constant           = */RSSGT_ATTR_AWGN_EB_TO_N0,

  /* debug name         = */"AWGN Eb to N0",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:ENR",
  /* integerDefault     = */0,
  /* doubleDefault      = */15.84,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_CARRIER_LEVEL =
{
  /* constant           = */RSSGT_ATTR_AWGN_CARRIER_LEVEL,

  /* debug name         = */"AWGN Carrier Level",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:POW:CARR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_NOISE_LEVEL =
{
  /* constant           = */RSSGT_ATTR_AWGN_NOISE_LEVEL,

  /* debug name         = */"AWGN Noise Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:POW:NOIS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_NOISE_LEVEL_TOTAL =
{
  /* constant           = */RSSGT_ATTR_AWGN_NOISE_LEVEL_TOTAL,

  /* debug name         = */"AWGN Noise Level Total",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:POW:NOIS:TOT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */-30.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_CARRIER_AND_NOISE_LEVEL =
{
  /* constant           = */RSSGT_ATTR_AWGN_CARRIER_AND_NOISE_LEVEL,

  /* debug name         = */"AWGN Carrier And Noise Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:POW:SUM?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_CARRIER_AND_NOISE_PEP =
{
  /* constant           = */RSSGT_ATTR_AWGN_CARRIER_AND_NOISE_PEP,

  /* debug name         = */"AWGN Carrier And Noise PEP",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":AWGN:POW:SUM:PEP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_AWGN_POWER_REFERENCE_MODE =
{
  /* constant           = */RSSGT_ATTR_AWGN_POWER_REFERENCE_MODE,
  /* debug name         = */"AWGNPowerRefMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngAWGNPowerRefMode,
  /* command            = */":AWGN:POW:RMOD",
  /* integerDefault     = */RSSGT_VAL_AWGN_REF_MODE_CARR,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_OUTPUT_ENABLED =
{
  /* constant           = */RSSGT_ATTR_OUTPUT_ENABLED,

  /* debug name         = */"Output Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":OUTP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadRfState_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteRfState_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BB_OPERATION_MODE =
{
  /* constant           = */RSSGT_ATTR_BB_OPERATION_MODE,
  /* debug name         = */"OperationMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngOperationMode,
  /* command            = */":OPM",
  /* integerDefault     = */RSSGT_VAL_OPERATION_MODE_NORM,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PATH_COUNT =
{
  /* constant           = */RSSGT_ATTR_PATH_COUNT,

  /* debug name         = */"Path Count",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":PATH:COUN?",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_RF_FREQUENCY,

  /* debug name         = */"RF Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":FREQ",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0e9,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadFrequency_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteFrequency_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_FREQUENCY_OFFSET =
{
  /* constant           = */RSSGT_ATTR_RF_FREQUENCY_OFFSET,

  /* debug name         = */"RF Frequency Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":FREQ:OFFS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_DELTA_PHASE =
{
  /* constant           = */RSSGT_ATTR_RF_DELTA_PHASE,

  /* debug name         = */"RF Delta Phase",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PHAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RESET_RF_DELTA_PHASE_DISPLAY =
{
  /* constant           = */RSSGT_ATTR_RESET_RF_DELTA_PHASE_DISPLAY,

  /* debug name         = */"Reset RF Delta Phase Display",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":PHAS:REF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_ENABLED =
{
  /* constant           = */RSSGT_ATTR_PULM_ENABLED,

  /* debug name         = */"PULM Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":PULM:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_POLARITY =
{
  /* constant           = */RSSGT_ATTR_PULM_POLARITY,
  /* debug name         = */"PULMPolarity",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPULMPolarity,
  /* command            = */":PULM:POL",
  /* integerDefault     = */RSSGT_VAL_PULM_POLARITY_NORMAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_SOURCE =
{
  /* constant           = */RSSGT_ATTR_PULM_SOURCE,
  /* debug name         = */"PULMSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPULMSource,
  /* command            = */":PULM:SOUR",
  /* integerDefault     = */RSSGT_VAL_PULM_SOURCE_INTERNAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_MODE =
{
  /* constant           = */RSSGT_ATTR_PULM_MODE,
  /* debug name         = */"PULMMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPULMMode,
  /* command            = */":PULM:MODE",
  /* integerDefault     = */RSSGT_VAL_PULSE_MODE_SINGLE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_PERIOD =
{
  /* constant           = */RSSGT_ATTR_PULM_PERIOD,

  /* debug name         = */"PULM Period",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PULM:PER",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.1e-9,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_WIDTH =
{
  /* constant           = */RSSGT_ATTR_PULM_WIDTH,

  /* debug name         = */"PULM Width",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PULM:WIDT",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0e-3,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_DELAY =
{
  /* constant           = */RSSGT_ATTR_PULM_DELAY,

  /* debug name         = */"PULM Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PULM:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */10.0e-9,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_DOUBLE_WIDTH =
{
  /* constant           = */RSSGT_ATTR_PULM_DOUBLE_WIDTH,

  /* debug name         = */"PULM Double Width",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PULM:DOUB:WIDT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.1e-9,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_DOUBLE_DELAY =
{
  /* constant           = */RSSGT_ATTR_PULM_DOUBLE_DELAY,

  /* debug name         = */"PULM Double Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PULM:DOUB:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0e-9,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_TRIGGER_MODE =
{
  /* constant           = */RSSGT_ATTR_PULM_TRIGGER_MODE,
  /* debug name         = */"PULMTriggerMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPULMTriggerMode,
  /* command            = */":PULM:TRIG:MODE",
  /* integerDefault     = */RSSGT_VAL_PULM_TRIGGER_MODE_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_IMPEDANCE =
{
  /* constant           = */RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_IMPEDANCE,
  /* debug name         = */"PULMExternalInputImpedance",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPULMExternalInputImpedance,
  /* command            = */":PULM:TRIG:EXT:IMP",
  /* integerDefault     = */RSSGT_VAL_INPUT_IMPEDANCE_G50,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_SLOPE =
{
  /* constant           = */RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_SLOPE,
  /* debug name         = */"ExternalTriggerSlope",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngExternalTriggerSlope,
  /* command            = */":PULM:TRIG:EXT:SLOP",
  /* integerDefault     = */RSSGT_VAL_PULSE_EXTERNAL_TRIGGER_SLOPE_POSITIVE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_GATE_POLARITY =
{
  /* constant           = */RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_GATE_POLARITY,
  /* debug name         = */"PulseModulationPolarity",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPulseModulationPolarity,
  /* command            = */":PULM:TRIG:EXT:GATE:POL",
  /* integerDefault     = */RSSGT_VAL_PULM_POLARITY_NORMAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ALC_ENABLED =
{
  /* constant           = */RSSGT_ATTR_ALC_ENABLED,
  /* debug name         = */"ALCEnabled",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngALCEnabled,
  /* command            = */":POW:ALC",
  /* integerDefault     = */RSSGT_VAL_POWER_ALC_STATE_TAB_ON,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ALC_SEARCH_ONCE =
{
  /* constant           = */RSSGT_ATTR_ALC_SEARCH_ONCE,

  /* debug name         = */"ALC Search Once",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":POW:ALC:SONC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ALC_DETECTOR_SENSITIVITY =
{
  /* constant           = */RSSGT_ATTR_ALC_DETECTOR_SENSITIVITY,
  /* debug name         = */"ALCDetectorSensitivity",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngALCDetectorSensitivity,
  /* command            = */":POW:ALC:DSEN",
  /* integerDefault     = */RSSGT_VAL_ALC_DETECTOR_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_AMPLITUDE =
{
  /* constant           = */RSSGT_ATTR_RF_AMPLITUDE,

  /* debug name         = */"RF Amplitude",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW",
  /* integerDefault     = */0,
  /* doubleDefault      = */-10.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadLevel_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteLevel_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_OFFSET =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_OFFSET,

  /* debug name         = */"RF Level Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:OFFS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL,

  /* debug name         = */"RF Level",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:POW",
  /* integerDefault     = */0,
  /* doubleDefault      = */-10.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_LIMIT =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_LIMIT,

  /* debug name         = */"RF Level Limit",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:LIM",
  /* integerDefault     = */0,
  /* doubleDefault      = */25.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_MODE =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_MODE,
  /* debug name         = */"RFLevelMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngRFLevelMode,
  /* command            = */":POW:LMOD",
  /* integerDefault     = */RSSGT_VAL_RF_LEVEL_MODE_NORMAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_SETTING_CHARACTERISTIC =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_SETTING_CHARACTERISTIC,
  /* debug name         = */"RFLevSettCharacteristic",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngRFLevSettCharacteristic,
  /* command            = */":POW:SCH",
  /* integerDefault     = */RSSGT_VAL_RF_LEVEL_CHARACTERISTIC_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_RANGE_MINIMUM =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_RANGE_MINIMUM,

  /* debug name         = */"RF Level Range Minimum",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:RANG:LOW?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_RANGE_MAXIMUM =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_RANGE_MAXIMUM,

  /* debug name         = */"RF Level Range Maximum",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:RANG:UPP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_PEP =
{
  /* constant           = */RSSGT_ATTR_RF_PEP,

  /* debug name         = */"RF PEP",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:PEP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_LEVEL_RANGE_WARNINGS =
{
  /* constant           = */RSSGT_ATTR_RF_LEVEL_RANGE_WARNINGS,

  /* debug name         = */"RF Level Range Warnings",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":POW:WIGN",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_ATTENUATOR_MODE =
{
  /* constant           = */RSSGT_ATTR_RF_ATTENUATOR_MODE,
  /* debug name         = */"RFAttenuatorMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngRFAttenuatorMode,
  /* command            = */":OUTP:AMOD",
  /* integerDefault     = */RSSGT_VAL_OUTPUT_AMODE_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_ATTENUATOR_LOWER_RANGE =
{
  /* constant           = */RSSGT_ATTR_RF_ATTENUATOR_LOWER_RANGE,

  /* debug name         = */"RF Attenuator Lower Range",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":OUTP:AFIX:RANG:LOW?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_ATTENUATOR_UPPER_RANGE =
{
  /* constant           = */RSSGT_ATTR_RF_ATTENUATOR_UPPER_RANGE,

  /* debug name         = */"RF Attenuator Upper Range",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":OUTP:AFIX:RANG:UPP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_ATTENUATOR_RF_OFF_MODE =
{
  /* constant           = */RSSGT_ATTR_RF_ATTENUATOR_RF_OFF_MODE,
  /* debug name         = */"RFAttRFOFFMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngRFAttRFOFFMode,
  /* command            = */":POW:ATT:RFOF:MODE",
  /* integerDefault     = */RSSGT_VAL_RF_OFF_MODE_UNCH,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_ATTENUATOR_SWITCH_OVER_OFFSET =
{
  /* constant           = */RSSGT_ATTR_RF_ATTENUATOR_SWITCH_OVER_OFFSET,

  /* debug name         = */"RF Attenuator Switch Over Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:ATT:SOV",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RF_ATTENUATION_DIGITAL =
{
  /* constant           = */RSSGT_ATTR_RF_ATTENUATION_DIGITAL,

  /* debug name         = */"Digital Attenuation",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":POW:ATT:DIG",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadDigitalAttenuation_Callback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)rssgt_WriteDigitalAttenuation_Callback,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_ON_ENABLED =
{
  /* constant           = */RSSGT_ATTR_POWER_ON_ENABLED,
  /* debug name         = */"PowerOnState",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPowerOnState,
  /* command            = */":OUTP:PON",
  /* integerDefault     = */RSSGT_VAL_OUTPUT_STATE_PON_OFF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_ENABLED =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_ENABLED,

  /* debug name         = */"User Correction Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":CORR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_VALUE =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_VALUE,

  /* debug name         = */"User Correction Value",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:VAL?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_CATALOG =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_CATALOG,

  /* debug name         = */"User Correction Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:CSET:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"catalog",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_SELECTED =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_SELECTED,

  /* debug name         = */"User Correction Selected",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:CSET",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_NUMBER_OF_FREQUENCIES =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_NUMBER_OF_FREQUENCIES,

  /* debug name         = */"User Correction Number Of Frequencies",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:CSET:DATA:FREQ:POIN?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_NUMBER_OF_POWERS =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_NUMBER_OF_POWERS,

  /* debug name         = */"User Correction Number Of Powers",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:CSET:DATA:POW:POIN?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_DELETE =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_DELETE,

  /* debug name         = */"User Correction Delete",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:CSET:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_CATALOG =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_CATALOG,

  /* debug name         = */"User Correction Import Export Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:DEXC:AFIL:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_EXTENSION =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_EXTENSION,
  /* debug name         = */"UserCorrectionImportExportExtension",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngUserCorrectionImportExportExtension,
  /* command            = */":CORR:DEXC:AFIL:EXT",
  /* integerDefault     = */RSSGT_VAL_FILE_FORMAT_TXT,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_ASCII_FILE =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_ASCII_FILE,

  /* debug name         = */"User Correction Import Export ASCII File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:DEXC:AFIL:SEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file1.csv",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_CORRECTION_FILE =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_CORRECTION_FILE,

  /* debug name         = */"User Correction Import Export Correction File",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:DEXC:SEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_COLUMN_SEPARATOR =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_COLUMN_SEPARATOR,
  /* debug name         = */"UserCorrectionImportExportColumnSeparator",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngUserCorrectionImportExportColumnSeparator,
  /* command            = */":CORR:DEXC:AFIL:SEP:COL",
  /* integerDefault     = */RSSGT_VAL_COLUMN_SEPARATOR_COMMA,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_DECIMAL_SEPARATOR =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_DECIMAL_SEPARATOR,
  /* debug name         = */"UserCorrectionImportExportDecimalSeparator",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngUserCorrectionImportExportDecimalSeparator,
  /* command            = */":CORR:DEXC:AFIL:SEP:DEC",
  /* integerDefault     = */RSSGT_VAL_DECIMAL_SEPARATOR_DOT,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_MODE =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_MODE,
  /* debug name         = */"UserCorrectionImportExportMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngUserCorrectionImportExportMode,
  /* command            = */":CORR:DEXC:MODE",
  /* integerDefault     = */RSSGT_VAL_IMPORT,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_EXECUTE =
{
  /* constant           = */RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_EXECUTE,

  /* debug name         = */"User Correction Import Export Execute",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":CORR:DEXC:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_LOSC_SOURCE =
{
  /* constant           = */RSSGT_ATTR_LOSC_SOURCE,
  /* debug name         = */"ReferenceOscillatorSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngReferenceOscillatorSource,
  /* command            = */":LOSC:SOUR",
  /* integerDefault     = */RSSGT_VAL_ROSC_SOURCE_INTERNAL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_ENABLED =
{
  /* constant           = */RSSGT_ATTR_BBIN_ENABLED,

  /* debug name         = */"BBIN Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_MODE =
{
  /* constant           = */RSSGT_ATTR_BBIN_MODE,
  /* debug name         = */"BBINMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngBBINMode,
  /* command            = */":BBIN:MODE",
  /* integerDefault     = */RSSGT_VAL_BBIN_MODE_ANALOG,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_IQ_SWAP =
{
  /* constant           = */RSSGT_ATTR_BBIN_IQ_SWAP,

  /* debug name         = */"BBIN IQ Swap",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:IQSW",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_IQ_SKEW =
{
  /* constant           = */RSSGT_ATTR_BBIN_IQ_SKEW,

  /* debug name         = */"BBIN IQ Skew",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:SKEW",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_CREST_FACTOR =
{
  /* constant           = */RSSGT_ATTR_BBIN_CREST_FACTOR,

  /* debug name         = */"BBIN Crest Factor",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:CFAC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_MEASUREMENT_PERIOD =
{
  /* constant           = */RSSGT_ATTR_BBIN_MEASUREMENT_PERIOD,

  /* debug name         = */"BBIN Measurement Period",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:MPER",
  /* integerDefault     = */2,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_AUTO_LEVEL_SET_ENABLED =
{
  /* constant           = */RSSGT_ATTR_BBIN_AUTO_LEVEL_SET_ENABLED,

  /* debug name         = */"BBIN Auto Level Set Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:DIG:ASET:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_AUTO_LEVEL_SET =
{
  /* constant           = */RSSGT_ATTR_BBIN_AUTO_LEVEL_SET,

  /* debug name         = */"BBIN Auto Level Set",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:ALEV:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_OVERLOAD_RESET =
{
  /* constant           = */RSSGT_ATTR_BBIN_OVERLOAD_RESET,

  /* debug name         = */"BBIN Overload Reset",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:OLO:HOLD:RES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_OVERLOAD_ENABLED =
{
  /* constant           = */RSSGT_ATTR_BBIN_OVERLOAD_ENABLED,

  /* debug name         = */"BBIN Overload Enabled",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:OLO:STAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_OVERLOAD_HOLD_ENABLED =
{
  /* constant           = */RSSGT_ATTR_BBIN_OVERLOAD_HOLD_ENABLED,

  /* debug name         = */"BBIN Overload Hold Enabled",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:OLO:HOLD:STAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_RMS_POWER =
{
  /* constant           = */RSSGT_ATTR_BBIN_RMS_POWER,

  /* debug name         = */"BBIN RMS Power",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:POW:RMS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_CURRENT_SAMPLE_RATE =
{
  /* constant           = */RSSGT_ATTR_BBIN_CURRENT_SAMPLE_RATE,

  /* debug name         = */"BBIN Current Sample Rate",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:SRAT:ACT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */100e6,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_PATH_GAIN =
{
  /* constant           = */RSSGT_ATTR_BBIN_PATH_GAIN,

  /* debug name         = */"BBIN Path Gain",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:PGA",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_FREQUENCY_OFFSET =
{
  /* constant           = */RSSGT_ATTR_BBIN_FREQUENCY_OFFSET,

  /* debug name         = */"BBIN Frequency Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:FOFF",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.00,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_EXTERNALLY_CONNECTED_ID =
{
  /* constant           = */RSSGT_ATTR_BBIN_EXTERNALLY_CONNECTED_ID,

  /* debug name         = */"BBIN Externally Connected ID",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:CDEV?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"id",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_SAMPLE_RATE_SOURCE =
{
  /* constant           = */RSSGT_ATTR_BBIN_SAMPLE_RATE_SOURCE,
  /* debug name         = */"BBINSRateSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngBBINSRateSource,
  /* command            = */":BBIN:SRAT:SOUR",
  /* integerDefault     = */RSSGT_VAL_BBIN_SRATE_USER,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_OUTPUT_DELAY =
{
  /* constant           = */RSSGT_ATTR_BBIN_OUTPUT_DELAY,

  /* debug name         = */"BBIN Output Delay",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:BBIN:ODEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_IMPAIRMENTS_GAIN_IMBALANCE =
{
  /* constant           = */RSSGT_ATTR_BBIN_IMPAIRMENTS_GAIN_IMBALANCE,

  /* debug name         = */"BBIN Impairments Gain Imbalance",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:GIMB",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_IMPAIRMENTS_I_OFFSET =
{
  /* constant           = */RSSGT_ATTR_BBIN_IMPAIRMENTS_I_OFFSET,

  /* debug name         = */"BBIN Impairments I Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:OFFS:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.000,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_BBIN_IMPAIRMENTS_Q_OFFSET =
{
  /* constant           = */RSSGT_ATTR_BBIN_IMPAIRMENTS_Q_OFFSET,

  /* debug name         = */"BBIN Impairments Q Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":BBIN:OFFS:Q",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_UNIT =
{
  /* constant           = */RSSGT_ATTR_POWER_UNIT,
  /* debug name         = */"PowerUnit",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPowerUnit,
  /* command            = */"SENS{Sense}:UNIT",
  /* integerDefault     = */RSSGT_VAL_SENSE_POWER_UNIT_DBM,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_POWER_FREQUENCY,

  /* debug name         = */"Power Frequency",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:FREQ",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.00e+9,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_RECORDER_STATE =
{
  /* constant           = */RSSGT_ATTR_POWER_RECORDER_STATE,

  /* debug name         = */"Power Recorder State",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":SENS{Sense}:LOGG:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_OFFSET =
{
  /* constant           = */RSSGT_ATTR_POWER_OFFSET,

  /* debug name         = */"Power Offset",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:OFFS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_OFFSET_ENABLED =
{
  /* constant           = */RSSGT_ATTR_POWER_OFFSET_ENABLED,

  /* debug name         = */"Power Offset Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:OFFS:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_SOURCE =
{
  /* constant           = */RSSGT_ATTR_POWER_SOURCE,
  /* debug name         = */"PowerSource",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPowerSource,
  /* command            = */"SENS{Sense}:SOUR",
  /* integerDefault     = */RSSGT_VAL_SENSE_POWER_SOURCE_RF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_ZERO =
{
  /* constant           = */RSSGT_ATTR_POWER_ZERO,

  /* debug name         = */"Power Zero",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:ZERO",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_CONTINUOUS =
{
  /* constant           = */RSSGT_ATTR_POWER_CONTINUOUS,

  /* debug name         = */"Power Continuous",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"INIT{Sense}:CONT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_USE_SPARAMETERS =
{
  /* constant           = */RSSGT_ATTR_POWER_USE_SPARAMETERS,

  /* debug name         = */"Power Use SParameters",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:CORR:SPD:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_DISPLAY_PERMANENT =
{
  /* constant           = */RSSGT_ATTR_POWER_DISPLAY_PERMANENT,
  /* debug name         = */"PowerDisplayPermanent",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPowerDisplayPermanent,
  /* command            = */":SENS{Sense}:DISP:PERM:PRI",
  /* integerDefault     = */RSSGT_VAL_SENSE_POWER_DISPLAY_AVERAGE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_DISPLAY_PERMANENT_ENABLED =
{
  /* constant           = */RSSGT_ATTR_POWER_DISPLAY_PERMANENT_ENABLED,

  /* debug name         = */"Power Display Permanent Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:DISP:PERM:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FILTER_LENGTH =
{
  /* constant           = */RSSGT_ATTR_POWER_FILTER_LENGTH,

  /* debug name         = */"Power Filter Length",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:FILT:LENG",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FILTER_MODE =
{
  /* constant           = */RSSGT_ATTR_POWER_FILTER_MODE,
  /* debug name         = */"PowerFilterMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPowerFilterMode,
  /* command            = */"SENS{Sense}:FILT:TYPE",
  /* integerDefault     = */RSSGT_VAL_SENSE_POWER_FILTER_TYPE_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FILTER_NS_RATIO =
{
  /* constant           = */RSSGT_ATTR_POWER_FILTER_NS_RATIO,

  /* debug name         = */"Power Filter NS Ratio",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:FILT:NSR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.01,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FILTER_NS_RATIO_TIMEOUT =
{
  /* constant           = */RSSGT_ATTR_POWER_FILTER_NS_RATIO_TIMEOUT,

  /* debug name         = */"Power Filter NS Ratio Timeout",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:FILT:NSR:MTIM",
  /* integerDefault     = */0,
  /* doubleDefault      = */4.00,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FILTER_LENGTH_AUTO =
{
  /* constant           = */RSSGT_ATTR_POWER_FILTER_LENGTH_AUTO,

  /* debug name         = */"Power Filter Length Auto",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:FILT:LENG:AUTO?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_FILTER_SEARCH_ONCE =
{
  /* constant           = */RSSGT_ATTR_POWER_FILTER_SEARCH_ONCE,

  /* debug name         = */"Power Filter Search Once",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:FILT:SONC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_SENSOR_DEVICE =
{
  /* constant           = */RSSGT_ATTR_POWER_SENSOR_DEVICE,

  /* debug name         = */"Power Sensor Device",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:STAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_SENSOR_TYPE =
{
  /* constant           = */RSSGT_ATTR_POWER_SENSOR_TYPE,

  /* debug name         = */"Power Sensor Type",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:TYPE?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"type",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_doubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_READ_POWER =
{
  /* constant           = */RSSGT_ATTR_POWER_READ_POWER,

  /* debug name         = */"Power Read Power Deprecated",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"READ{Sense}?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_SENSOR_VERSION =
{
  /* constant           = */RSSGT_ATTR_POWER_SENSOR_VERSION,

  /* debug name         = */"Power Sensor Version",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:SVER?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"version",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_doubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_SENSOR_SERIAL_NUMBER =
{
  /* constant           = */RSSGT_ATTR_POWER_SENSOR_SERIAL_NUMBER,

  /* debug name         = */"Power Sensor Serial Number",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SENS{Sense}:SNUM?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"serialNumber",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_doubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_DEFAULT_APERTURE_TIME_ENABLED =
{
  /* constant           = */RSSGT_ATTR_POWER_DEFAULT_APERTURE_TIME_ENABLED,

  /* debug name         = */"Power Default Aperture Time Enabled",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":SENS{Sense}:APER:DEF:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_TRUE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_APERTURE_TIME =
{
  /* constant           = */RSSGT_ATTR_POWER_APERTURE_TIME,

  /* debug name         = */"Power Aperture Time",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":SENS{Sense}:APER:TIM",
  /* integerDefault     = */0,
  /* doubleDefault      = */20.0e-3,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_BASEBAND_ADD_MEASUREMENT =
{
  /* constant           = */RSSGT_ATTR_POWER_BASEBAND_ADD_MEASUREMENT,

  /* debug name         = */"Power Baseband Add Measurement",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BB:MEAS:POW:ADD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_BASEBAND_CHANGE_MEASUREMENT =
{
  /* constant           = */RSSGT_ATTR_POWER_BASEBAND_CHANGE_MEASUREMENT,

  /* debug name         = */"Power Baseband Change Measurement",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BB:MEAS:POW:CHAN",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_BASEBAND_DELETE_MEASUREMENT =
{
  /* constant           = */RSSGT_ATTR_POWER_BASEBAND_DELETE_MEASUREMENT,

  /* debug name         = */"Power Baseband Delete Measurement",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BB:MEAS:POW:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_BASEBAND_EXECUTE_MEASUREMENT =
{
  /* constant           = */RSSGT_ATTR_POWER_BASEBAND_EXECUTE_MEASUREMENT,

  /* debug name         = */"Power Baseband Execute Measurement",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BB:MEAS:POW:EXEC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_POWER_BASEBAND_ABORT =
{
  /* constant           = */RSSGT_ATTR_POWER_BASEBAND_ABORT,

  /* debug name         = */"Power Baseband Abort",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":BB:MEAS:POW:ABOR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_STATE =
{
  /* constant           = */RSSGT_ATTR_PSER_STATE,

  /* debug name         = */"Power Servoing State",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":POW:SERV:STAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_TARGET =
{
  /* constant           = */RSSGT_ATTR_PSER_TARGET,

  /* debug name         = */"Power Servoing Target Level",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */&rssgt_rngPowerServoingTargetLevel,
  /* command            = */":POW:SERV:TARG",
  /* integerDefault     = */0,
  /* doubleDefault      = */-10.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_TOL =
{
  /* constant           = */RSSGT_ATTR_PSER_TOL,

  /* debug name         = */"Power Servoing Level Tolerance",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */&rssgt_rngPowerServoingLevelTolerance,
  /* command            = */":POW:SERV:TOL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.01,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_TEST =
{
  /* constant           = */RSSGT_ATTR_PSER_TEST,

  /* debug name         = */"Power Servoing Test",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":POW:SERV:TEST?",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_TRACK =
{
  /* constant           = */RSSGT_ATTR_PSER_TRACK,

  /* debug name         = */"Power Servoing Tracking",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":POW:SERV:TRAC",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_SENSOR =
{
  /* constant           = */RSSGT_ATTR_PSER_SENSOR,
  /* debug name         = */"PowerServoingSensorSelect",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngPowerServoingSensorSelect,
  /* command            = */":POW:SERV:SENS",
  /* integerDefault     = */RSSGT_VAL_POWER_CONTROL_SENSUNDEF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_PSER_APER =
{
  /* constant           = */RSSGT_ATTR_PSER_APER,

  /* debug name         = */"Power Servoing Aperture",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */&rssgt_rngPowerServoingAperture,
  /* command            = */":POW:SERV:SENS:APER",
  /* integerDefault     = */0,
  /* doubleDefault      = */100.0e-6,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CLOCK_INPUT_SLOPE =
{
  /* constant           = */RSSGT_ATTR_CLOCK_INPUT_SLOPE,
  /* debug name         = */"Slope",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSlope,
  /* command            = */":CLOC:INP:SLOP",
  /* integerDefault     = */RSSGT_VAL_SLOPE_POSITIVE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CLOCK_MODE =
{
  /* constant           = */RSSGT_ATTR_CLOCK_MODE,
  /* debug name         = */"GlobalClockMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngGlobalClockMode,
  /* command            = */":CLOC:OUTP:MODE",
  /* integerDefault     = */RSSGT_VAL_CLOCK_OUTPUT_MODE_SYMBOL,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CLOCK_INPUT_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_CLOCK_INPUT_FREQUENCY,

  /* debug name         = */"Clock Input Frequency",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":CLOC:INP:FREQ?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_RESTART =
{
  /* constant           = */RSSGT_ATTR_RESTART,

  /* debug name         = */"Restart",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":REST",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_STANDBY =
{
  /* constant           = */RSSGT_ATTR_STANDBY,

  /* debug name         = */"Standby",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":STAN",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_UNLOCK =
{
  /* constant           = */RSSGT_ATTR_UNLOCK,

  /* debug name         = */"Unlock",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":UNL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_USER_PATH =
{
  /* constant           = */RSSGT_ATTR_USER_PATH,

  /* debug name         = */"User Path",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:MMEM:PATH:USER?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"path",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_ID_QUERY_RESPONSE =
{
  /* constant           = */RSSGT_ATTR_ID_QUERY_RESPONSE,

  /* debug name         = */"ID Query Response",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */NULL,
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_NOT_WRITABLE | RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_ALL =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_ALL,

  /* debug name         = */"Calibration All",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:ALL?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_FREQUENCY,

  /* debug name         = */"Calibration Frequency",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:FREQ:MEAS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_FREQUENCY_TEMPERATURE =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_FREQUENCY_TEMPERATURE,

  /* debug name         = */"Calibration Frequency Temperature",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:FREQ:TEMP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_FULL =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_FULL,

  /* debug name         = */"Calibration IQ Modulator Full",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:IQM:FULL?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_LOCAL =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_LOCAL,

  /* debug name         = */"Calibration IQ Modulator Local",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:IQM:LOC?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_TEMPERATURE =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_TEMPERATURE,

  /* debug name         = */"Calibration IQ Modulator Temperature",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:IQM:TEMP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_LEVEL =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_LEVEL,

  /* debug name         = */"Calibration Level",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:LEV:MEAS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_LEVEL_TEMPERATURE =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_LEVEL_TEMPERATURE,

  /* debug name         = */"Calibration Level Temperature",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:LEV:TEMP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0.0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CALIBRATION_IQ_INPUT =
{
  /* constant           = */RSSGT_ATTR_CALIBRATION_IQ_INPUT,

  /* debug name         = */"Calibration IQ Input",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":CAL:BBIN?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TEST_ALL_START =
{
  /* constant           = */RSSGT_ATTR_TEST_ALL_START,

  /* debug name         = */"Test All Start",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":TEST:ALL:STAR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TEST_ALL_RESULT =
{
  /* constant           = */RSSGT_ATTR_TEST_ALL_RESULT,

  /* debug name         = */"Test All Result",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":TEST:ALL:RES?",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TEST_KEYBOARD =
{
  /* constant           = */RSSGT_ATTR_TEST_KEYBOARD,

  /* debug name         = */"Test Keyboard",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":TEST:KEYB",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TEST_EXTERNAL_IQ_DEVICES =
{
  /* constant           = */RSSGT_ATTR_TEST_EXTERNAL_IQ_DEVICES,
  /* debug name         = */"TestExternalIQDevices",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngTestExternalIQDevices,
  /* command            = */":TEST:EIQM",
  /* integerDefault     = */RSSGT_VAL_TEST_EXTERNAL_IQ_OUT,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TEST_BASEBAND_INPUT =
{
  /* constant           = */RSSGT_ATTR_TEST_BASEBAND_INPUT,

  /* debug name         = */"Test Baseband Input",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":TEST:BBIN?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_DIAGNOSTIC_TEST_POINTS =
{
  /* constant           = */RSSGT_ATTR_DIAGNOSTIC_TEST_POINTS,

  /* debug name         = */"Diagnostic Test Points",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":DIAG:POIN:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"testPoints",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_ReadOnlyCollection_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_MMEMORY_CHANGE_DIRECTORY =
{
  /* constant           = */RSSGT_ATTR_MMEMORY_CHANGE_DIRECTORY,

  /* debug name         = */"MMEMory Change Directory",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":MMEM:CDIR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"..",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_MMEMORY_DELETE =
{
  /* constant           = */RSSGT_ATTR_MMEMORY_DELETE,

  /* debug name         = */"MMEMory Delete",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":MMEM:DEL",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"file1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_MMEMORY_MAKE_DIRECTORY =
{
  /* constant           = */RSSGT_ATTR_MMEMORY_MAKE_DIRECTORY,

  /* debug name         = */"MMEMory Make Directory",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":MMEM:MDIR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"New_Folder",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_MMEMORY_REMOVE_DIRECTORY =
{
  /* constant           = */RSSGT_ATTR_MMEMORY_REMOVE_DIRECTORY,

  /* debug name         = */"MMEMory Remove Directory",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":MMEM:RDIR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"New_Folder",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_FACTORY_PRESET =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_FACTORY_PRESET,

  /* debug name         = */"System Factory Preset",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:FPR",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR,

  /* debug name         = */"System Error",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:ERR?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"error",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_ALL =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR_QUEUE_ALL,

  /* debug name         = */"System Error Queue All",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:ERR:ALL?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_CODE_ALL =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR_QUEUE_CODE_ALL,

  /* debug name         = */"System Error Queue Code All",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:ERR:CODE:ALL?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_CODE_NEXT =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR_QUEUE_CODE_NEXT,

  /* debug name         = */"System Error Queue Code Next",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:ERR:CODE?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_COUNT =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR_QUEUE_COUNT,

  /* debug name         = */"System Error Queue Count",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:ERR:COUN?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_NEXT =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR_QUEUE_NEXT,

  /* debug name         = */"System Error Queue Next",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":STAT:QUE?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_ERROR_ALL =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_ERROR_ALL,

  /* debug name         = */"System Error All",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:SERR?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */RS_VAL_DONT_CHECK_STATUS,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_VERSION =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_VERSION,

  /* debug name         = */"System Version",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:VERS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"version",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_PRESET =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_PRESET,

  /* debug name         = */"System Preset",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:PRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_STARTUP_COMPLETE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_STARTUP_COMPLETE,

  /* debug name         = */"System Startup Complete",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:STAR:COMP?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_USB_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_USB_RESOURCE,

  /* debug name         = */"System USB Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:USB:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"usb",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_doubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_GPIB_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_GPIB_RESOURCE,

  /* debug name         = */"System GPIB Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SYST:COMM:GPIB:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"resource",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_GPIB_ADDRESS =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_GPIB_ADDRESS,

  /* debug name         = */"System GPIB Address",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */NULL,
  /* command            = */"SYST:COMM:GPIB:ADDR",
  /* integerDefault     = */28,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_GPIB_LINE_TERMINATOR =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_GPIB_LINE_TERMINATOR,
  /* debug name         = */"SystemGPIBLineTerminator",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSystemGPIBLineTerminator,
  /* command            = */"SYST:COMM:GPIB:LTER",
  /* integerDefault     = */RSSGT_VAL_GPIB_LINE_TERM_STANDARD,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_SERIAL_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_SERIAL_RESOURCE,

  /* debug name         = */"System Serial Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:SER:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"ASRL1::INSTR",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_SERIAL_BAUD =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_SERIAL_BAUD,
  /* debug name         = */"SystemSerialBaud",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSystemSerialBaud,
  /* command            = */":SYST:COMM:SER:BAUD",
  /* integerDefault     = */115200,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_SERIAL_PARITY =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_SERIAL_PARITY,
  /* debug name         = */"SystemSerialParity",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSystemSerialParity,
  /* command            = */":SYST:COMM:SER:PAR",
  /* integerDefault     = */RSSGT_VAL_SERIAL_PARITY_NONE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_SERIAL_STOP_BITS =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_SERIAL_STOP_BITS,
  /* debug name         = */"SystemSerialStopBits",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSystemSerialStopBits,
  /* command            = */":SYST:COMM:SER:SBIT",
  /* integerDefault     = */1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_HISLIP_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_HISLIP_RESOURCE,

  /* debug name         = */"System HiSLIP Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:HISL:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"hislip",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_PCI_EXPRESS_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_PCI_EXPRESS_RESOURCE,

  /* debug name         = */"System PCI Express Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:PCI:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"PCIe",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_SOCKET_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_SOCKET_RESOURCE,

  /* debug name         = */"System Socket Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:SOCK:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"socket",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_OPERATING_SYSTEM =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_OPERATING_SYSTEM,

  /* debug name         = */"System Operating System",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:OSYS?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"XP",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_UPTIME =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_UPTIME,

  /* debug name         = */"System Uptime",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:UPT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"time",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_RESTART =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_RESTART,

  /* debug name         = */"System Network Restart",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:REST",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_STATUS =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_STATUS,

  /* debug name         = */"System Network Status",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:STAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_RESOURCE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_RESOURCE,

  /* debug name         = */"System Network Resource",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:RES?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"resource",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_doubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_MAC_ADDRESS =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_MAC_ADDRESS,

  /* debug name         = */"System Network Mac Address",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:MAC?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"macAddress",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)rssgt_doubleQuotedString_ReadCallback,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_HOST_NAME =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_HOST_NAME,

  /* debug name         = */"System Network Host Name",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:HOST",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"host",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS,

  /* debug name         = */"System Network IP Address",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:IPAD",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"192.168.0.1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_SUBNET_MASK =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_SUBNET_MASK,

  /* debug name         = */"System Network IP Address Subnet Mask",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:IPAD:SUBN:MASK",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"255.255.255.0",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_GATEWAY =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_GATEWAY,

  /* debug name         = */"System Network IP Address Gateway",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:COMM:NETW:IPAD:GAT",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"192.168.0.1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_MODE =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_MODE,
  /* debug name         = */"SystemIPAddressMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSystemIPAddressMode,
  /* command            = */":SYST:COMM:NETW:IPAD:MODE",
  /* integerDefault     = */RSSGT_VAL_SYSTEM_COMMUNICATE_IP_MODE_AUTO,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_DNS =
{
  /* constant           = */RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_DNS,

  /* debug name         = */"System Network IP Address DNS",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */"SYST:COMM:NETW:DNS",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"123.456.0.1",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_STATUS_PRESET =
{
  /* constant           = */RSSGT_ATTR_STATUS_PRESET,

  /* debug name         = */"Status Preset",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */":STAT:PRES",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_UNIT_ANGLE =
{
  /* constant           = */RSSGT_ATTR_UNIT_ANGLE,
  /* debug name         = */"UnitAngle",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngUnitAngle,
  /* command            = */":UNIT:ANGL",
  /* integerDefault     = */RSSGT_VAL_UNIT_ANGLE_RAD,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_UNIT_POWER =
{
  /* constant           = */RSSGT_ATTR_UNIT_POWER,
  /* debug name         = */"UnitPower",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngUnitPower,
  /* command            = */":UNIT:POW",
  /* integerDefault     = */RSSGT_VAL_UNIT_POWER_DBM,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_OUTPUT =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_OUTPUT,
  /* debug name         = */"ConnectorOutput",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngConnectorOutput,
  /* command            = */":CONN:REFL:OUTP",
  /* integerDefault     = */RSSGT_VAL_CONNECTOR_OUTPUT_REF,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_OPERATION_MODE =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_OPERATION_MODE,
  /* debug name         = */"ConnectorOperationMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngConnectorOperationMode,
  /* command            = */":CONN:USER{User}:OMOD",
  /* integerDefault     = */RSSGT_VAL_CONN_OPMODE_MKR1,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_THRESHOLD =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_THRESHOLD,

  /* debug name         = */"Connector Threshold",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":CONN:USER{User}:THR",
  /* integerDefault     = */0,
  /* doubleDefault      = */1.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_CLOCK_IMPEDANCE =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_CLOCK_IMPEDANCE,
  /* debug name         = */"ConnectorImpedance",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngConnectorImpedance,
  /* command            = */":CONN:USER{User}:CLOC:IMP",
  /* integerDefault     = */RSSGT_VAL_CONN_IMPEDANCE_G10K,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_CLOCK_SLOPE =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_CLOCK_SLOPE,
  /* debug name         = */"Slope",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSlope,
  /* command            = */":CONN:USER{User}:CLOC:SLOP",
  /* integerDefault     = */RSSGT_VAL_SLOPE_POSITIVE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_TRIGGER_IMPEDANCE =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_TRIGGER_IMPEDANCE,
  /* debug name         = */"ConnectorImpedance",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngConnectorImpedance,
  /* command            = */":CONN:USER{User}:TRIG:IMP",
  /* integerDefault     = */RSSGT_VAL_CONN_IMPEDANCE_G10K,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_CONNECTOR_TRIGGER_SLOPE =
{
  /* constant           = */RSSGT_ATTR_CONNECTOR_TRIGGER_SLOPE,
  /* debug name         = */"Slope",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngSlope,
  /* command            = */":CONN:USER{User}:TRIG:SLOP",
  /* integerDefault     = */RSSGT_VAL_SLOPE_POSITIVE,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_TRUE
};

RsAttrProperties  g_RSSGT_ATTR_FAST_SPEED_RF_OUTPUT_FREQUENCY =
{
  /* constant           = */RSSGT_ATTR_FAST_SPEED_RF_OUTPUT_FREQUENCY,

  /* debug name         = */"Fast Speed RF Output Frequency",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":FFAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */1275000000.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_FAST_SPEED_RF_OUTPUT_LEVEL =
{
  /* constant           = */RSSGT_ATTR_FAST_SPEED_RF_OUTPUT_LEVEL,

  /* debug name         = */"Fast Speed RF Output Level",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */":PFAS",
  /* integerDefault     = */0,
  /* doubleDefault      = */-20.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_FORMAT_SEQUENCE_OF_BYTES =
{
  /* constant           = */RSSGT_ATTR_FORMAT_SEQUENCE_OF_BYTES,
  /* debug name         = */"FormatSequenceOfBytes",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngFormatSequenceOfBytes,
  /* command            = */":FORM:BORD",
  /* integerDefault     = */RSSGT_VAL_FORMAT_BORDER_NORM,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_FORMAT_STATUS_REGISTER =
{
  /* constant           = */RSSGT_ATTR_FORMAT_STATUS_REGISTER,
  /* debug name         = */"FormatStatusRegister",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngFormatStatusRegister,
  /* command            = */":FORM:SREG",
  /* integerDefault     = */RSSGT_VAL_FORMAT_SREG_ASCII,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_FORMAT_DATA =
{
  /* constant           = */RSSGT_ATTR_FORMAT_DATA,
  /* debug name         = */"FormatData",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngFormatData,
  /* command            = */":FORM",
  /* integerDefault     = */RSSGT_VAL_FORMAT_DATA_ASCII,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TIME_ZONE =
{
  /* constant           = */RSSGT_ATTR_TIME_ZONE,

  /* debug name         = */"Time Zone",

  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:TIME:ZONE",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"A/AA/aab",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_TIME_ZONE_CATALOG =
{
  /* constant           = */RSSGT_ATTR_TIME_ZONE_CATALOG,

  /* debug name         = */"Time Zone Catalog",

  /* access             = */RS_VAL_READ_ONLY,
  /* dataType           = */RS_VAL_STRING,
  /* rangeTable         = */NULL,
  /* command            = */":SYST:TIME:ZONE:CAT?",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */"catalog",
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_INIT_SW_TRIGGER =
{
  /* constant           = */RSSGT_ATTR_INIT_SW_TRIGGER,

  /* debug name         = */"Init Software Trigger",

  /* access             = */RS_VAL_WRITE_ONLY,
  /* dataType           = */RS_VAL_EVENT,
  /* rangeTable         = */NULL,
  /* command            = */"*TRG",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

// manually added attributes
RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_MODE =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_MODE,
  /* debug name         = */"IQOutputAnalogMode",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_INT32,
  /* rangeTable         = */&rssgt_rngIQOutputAnalogMode,
  /* command            = */"SOUR:IQ:OUTP:MODE",
  /* integerDefault     = */RSSGT_VAL_IQ_OUTPUT_ANALOG_MODE_FIXED,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_BIAS_COUPLING_STATE =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_BIAS_COUPLING_STATE,
  /* debug name         = */"IQOutputAnalogBiasCouplingState",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_BOOLEAN,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:BIAS:COUP",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};

RsAttrProperties  g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_BIAS_I =
{
  /* constant           = */RSSGT_ATTR_IQ_OUTPUT_ANALOG_BIAS_I,
  /* debug name         = */"IQOutputAnalogBiasI",
  /* access             = */RS_VAL_READ_WRITE,
  /* dataType           = */RS_VAL_REAL64,
  /* rangeTable         = */NULL,
  /* command            = */"SOUR:IQ:OUTP:BIAS:I",
  /* integerDefault     = */0,
  /* doubleDefault      = */0.0,
  /* booleanDefault     = */VI_FALSE,
  /* stringDefault      = */NULL,
  /* sessionDefault     = */0,
  /* comparePrecision   = */0.001,
  /* readCallback       = */(RsReadAttr_CallbackPtr)NULL,
  /* writeCallback      = */(RsWriteAttr_CallbackPtr)NULL,
  /* checkCallback      = */(RsCheckAttr_CallbackPtr)NULL,
  /* checkStatusCallback      = */(RsCheckStatusAttr_CallbackPtr)NULL,
  /* coerceCallback     = */(RsCoerceAttr_CallbackPtr)NULL,
  /* rngTableCallback   = */(RsRangeTable_CallbackPtr)NULL,
  /* userCallback       = */(RsUserAttr_CallbackPtr)NULL,
  /* flags              = */0,
  /* supportedModels    = */NULL,
  /* instrumentOptions  = */NULL,
  /* p2value            = */NULL,
  /* usercaps           = */VI_FALSE
};



/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/

RsAttrPropertiesPtr rssgt_RsAttrPropertiesList[] =
{
&g_RSSGT_RS_ATTR_RANGE_CHECK,
&g_RSSGT_RS_ATTR_QUERY_INSTRUMENT_STATUS,
&g_RSSGT_RS_ATTR_CACHE,
&g_RSSGT_RS_ATTR_SIMULATE,
&g_RSSGT_RS_ATTR_RECORD_COERCIONS,
&g_RSSGT_RS_ATTR_INTERCHANGE_CHECK,
&g_RSSGT_RS_ATTR_SPY,
&g_RSSGT_RS_ATTR_USE_SPECIFIC_SIMULATION,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_DESCRIPTION,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_PREFIX,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_VENDOR,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_REVISION,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_CLASS_SPEC_MAJOR_VERSION,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_CLASS_SPEC_MINOR_VERSION,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_PREFIX,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_VENDOR,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_REVISION,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
&g_RSSGT_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
&g_RSSGT_RS_ATTR_GROUP_CAPABILITIES,
&g_RSSGT_RS_ATTR_FUNCTION_CAPABILITIES,
&g_RSSGT_RS_ATTR_CHANNEL_COUNT,
&g_RSSGT_RS_ATTR_DRIVER_SETUP,
&g_RSSGT_RS_ATTR_INSTRUMENT_MANUFACTURER,
&g_RSSGT_RS_ATTR_INSTRUMENT_MODEL,
&g_RSSGT_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
&g_RSSGT_RS_ATTR_OPTIONS_LIST,
&g_RSSGT_RS_ATTR_IO_RESOURCE_DESCRIPTOR,
&g_RSSGT_RS_ATTR_LOGICAL_NAME,
&g_RSSGT_RS_ATTR_PRIMARY_ERROR,
&g_RSSGT_RS_ATTR_SECONDARY_ERROR,
&g_RSSGT_RS_ATTR_ERROR_ELABORATION,
&g_RSSGT_RS_ATTR_VISA_RM_SESSION,
&g_RSSGT_RS_ATTR_IO_SESSION,
&g_RSSGT_RS_ATTR_IO_SESSION_TYPE,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
&g_RSSGT_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
&g_RSSGT_RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
&g_RSSGT_RS_ATTR_ENGINE_MAJOR_VERSION,
&g_RSSGT_RS_ATTR_ENGINE_MINOR_VERSION,
&g_RSSGT_RS_ATTR_ENGINE_REVISION,
&g_RSSGT_RS_ATTR_OPC_CALLBACK,
&g_RSSGT_RS_ATTR_CHECK_STATUS_CALLBACK,
&g_RSSGT_RS_ATTR_OPC_TIMEOUT,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_SOURCE,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_EXTERNAL_FREQUENCY,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_OUTPUT_FREQUENCY,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_SYNCHRONIZATION_BANDWIDTH,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_ACTIVE,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_SMALL_SHIFT,
&g_RSSGT_ATTR_REFERENCE_OSCILLATOR_ADJUSTMENT_CALIBRATION_VALUE,
&g_RSSGT_ATTR_BB_SYSTEM_CONFIGURATION,
&g_RSSGT_ATTR_BB_FREQUENCY_OFFSET,
&g_RSSGT_ATTR_BB_PATH_GAIN,
&g_RSSGT_ATTR_BB_PHASE_OFFSET,
&g_RSSGT_ATTR_BB_PULSE_SEQUENCER_INFO,
&g_RSSGT_ATTR_PATH,
&g_RSSGT_ATTR_ARB_ENABLED,
&g_RSSGT_ATTR_ARB_SET_TO_DEFAULT,
&g_RSSGT_ATTR_ARB_CLOCK_FREQUENCY,
&g_RSSGT_ATTR_ARB_WAVEFORM_CATALOG,
&g_RSSGT_ATTR_ARB_WAVEFORM_CATALOG_LENGTH,
&g_RSSGT_ATTR_ARB_WAVEFORM_DELETE,
&g_RSSGT_ATTR_ARB_WAVEFORM_POINTS,
&g_RSSGT_ATTR_ARB_WAVEFORM_SELECT,
&g_RSSGT_ATTR_ARB_TRIGGER_STATUS,
&g_RSSGT_ATTR_ARB_TRIGGER_ARM_EXECUTE,
&g_RSSGT_ATTR_ARB_EXECUTE_TRIGGER,
&g_RSSGT_ATTR_ARB_TRIGGER_DELAY_UNIT,
&g_RSSGT_ATTR_ARB_TRIGGER_MODE,
&g_RSSGT_ATTR_ARB_EXTENDED_TRIGGER_MODE,
&g_RSSGT_ATTR_ARB_TRIGGER_SOURCE,
&g_RSSGT_ATTR_ARB_TRIGGER_SINGLE_SEQUENCE_LENGTH,
&g_RSSGT_ATTR_ARB_TRIGGER_SINGLE_SIGNAL_DURATION_UNIT,
&g_RSSGT_ATTR_ARB_EXTERNAL_SYNCHRONIZE_OUTPUT,
&g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_DELAY,
&g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_INHIBIT,
&g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_TIME_DELAY,
&g_RSSGT_ATTR_ARB_EXTERNAL_TRIGGER_TIME_EVENT_DELAY,
&g_RSSGT_ATTR_ARB_MARKER_MODE,
&g_RSSGT_ATTR_ARB_MARKER_PULSE_DIVIDER,
&g_RSSGT_ATTR_ARB_MARKER_PULSE_FREQUENCY,
&g_RSSGT_ATTR_ARB_MARKER_PATTERN,
&g_RSSGT_ATTR_ARB_MARKER_ON_TIME,
&g_RSSGT_ATTR_ARB_MARKER_OFF_TIME,
&g_RSSGT_ATTR_ARB_MARKER_DELAY,
&g_RSSGT_ATTR_ARB_FIXED_MARKER_DELAY_MAXIMUM,
&g_RSSGT_ATTR_ARB_FIXED_MARKER_DELAY_MINIMUM,
&g_RSSGT_ATTR_ARB_CLOCK_SOURCE,
&g_RSSGT_ATTR_ARB_CLOCK_MODE,
&g_RSSGT_ATTR_ARB_CHIP_CLOCK_MULTIPLIER,
&g_RSSGT_ATTR_ARB_CLOCK_SYNCHRONISATION_MODE,
&g_RSSGT_ATTR_ARB_TSIGNAL_SINE_NAME,
&g_RSSGT_ATTR_ARB_TSIGNAL_SINE_CREATE,
&g_RSSGT_ATTR_ARB_TSIGNAL_SINE_FREQUENCY,
&g_RSSGT_ATTR_ARB_TSIGNAL_SINE_PHASE,
&g_RSSGT_ATTR_ARB_TSIGNAL_SINE_SAMPLES,
&g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_NAME,
&g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_CREATE,
&g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_FREQUENCY,
&g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_AMPLITUDE,
&g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_OFFSET_DC,
&g_RSSGT_ATTR_ARB_TSIGNAL_RECTANGLE_SAMPLES,
&g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_NAME,
&g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_CREATE,
&g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_I,
&g_RSSGT_ATTR_ARB_TSIGNAL_CIQ_Q,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_STREAMING_ENABLED,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_FREE_DISK_SPACE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_FILLING_LEVEL_STREAMING_BUFFER,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_OUTPUT_SEGMENT,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_CURRENT_OUTPUT_SEGMENT,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_LEVEL_MODE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_MARKER_MODE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_SEQUENCE_RESTART,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_SEGMENT_RESTART,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_SAVE_FILE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_APPEND_FILE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_NAME,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_LEVEL,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_EXECUTE_NEXT_SEGMENT,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_NEXT_SEGMENT_SOURCE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_SEQUENCING_LIST,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_CONFIGURATION_FILE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_CREATE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_LOAD_FROM_CONFIGURATION_FILE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_CATALOG,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_SEGMENT_CATALOG,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_DELETE_CONFIGURATION_FILE,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_COMMENT,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_CLOCK,
&g_RSSGT_ATTR_ARB_MULTISEGMENT_CLOCK_MODE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CREATE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLOCK,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_RESET,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_MODE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CREST_FACTOR_MODE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_OUTPUT_FILE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_SAVE_FILE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_SAMPLES,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_SIGNAL_PERIOD_MODE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_SIGNAL_PERIOD,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_POWER_REFERENCE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_COUNT,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_SPACING,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_FREQUENCY,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_DELAY,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_DATA_FILE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_PHASE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_POWER,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_ENABLED,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CONFLICT,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_EXECUTE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_DELAY,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_DELAY_STEP,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_INPUT_IQ_FILE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_PHASE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_PHASE_STEP,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_POWER,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_POWER_STEP,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_START,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_STOP,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_EDIT_ENABLED,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_STORE_FAST,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_CATALOG,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_LOAD,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_FILE_STORE,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_ENABLED,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_TARGET_CREST_FACTOR,
&g_RSSGT_ATTR_ARB_MULTI_CARRIER_CLIPPING_FILTER_CUT_OFF_FREQUENCY,
&g_RSSGT_ATTR_PROGRESS_MULTI_CODER,
&g_RSSGT_ATTR_PROGRESS_MULTI_CARRIER,
&g_RSSGT_ATTR_PROGRESS_MULTI_SEGMENT,
&g_RSSGT_ATTR_IQ_ENABLED,
&g_RSSGT_ATTR_IQ_WIDEBAND_ENABLED,
&g_RSSGT_ATTR_IQ_ANALOG_WIDEBAND_CREST_FACTOR,
&g_RSSGT_ATTR_IQ_OUTPUT_LEVEL_ENTRY,
&g_RSSGT_ATTR_IQ_OUTPUT_DIGITAL_OVERFLOW_RESET,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_ENABLED,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_SET_TO_DEFAULT,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_TYPE,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_LOAD_SETTINGS,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_STORE_SETTINGS,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_DELETE_SETTINGS,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_SETTINGS_CATALOG,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_I_OFFSET,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_Q_OFFSET,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_DISPLAY_POWER_VIA,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_RF_ENVELOPE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VOLTAGE_ADAPTATION,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_ETRACK_INTERFACE_TYPE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VOLTAGE_REFERENCE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VOUT_MAX,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VOUT_MIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_BIAS,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_OFFSET,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VPP_MAX,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_EMF_ENABLED,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_RIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_TERMINATION,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_BIPOLAR_INPUT_ENABLED,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_GAIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VCC_OFFSET,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VCC_MAX,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_VCC_MIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_PEP_IN_MAX,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_PEP_IN_MIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_POWER_OFFSET,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_DELAY,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_CALCULATE_ENVELOPE_FROM_PREDISTORTED_SIGNAL,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_FUNCTION,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_COUPLE_DETROUGHING_FACTOR_WITH_VCC,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_FACTOR,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_DETROUGHING_EXPONENT,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PRE_GAIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POST_GAIN,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_INTERPOLATION,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_SCALE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_CLIPPING_FROM,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_CLIPPING_TO,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_FILE_CATALOG,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_SELECT_FILE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PV_FILE_CATALOG,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_PV_SELECT_FILE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_FILE_CATALOG,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_LOAD_FILE,
&g_RSSGT_ATTR_ENVELOPE_TRACKING_SHAPING_POLYNOMIAL_SAVE_FILE,
&g_RSSGT_ATTR_IQ_MODULATION_IMPAIRMENTS_ENABLED,
&g_RSSGT_ATTR_IQ_I_OFFSET,
&g_RSSGT_ATTR_IQ_Q_OFFSET,
&g_RSSGT_ATTR_IQ_GAIN_IMBALANCE,
&g_RSSGT_ATTR_IQ_QUADRATURE_OFFSET,
&g_RSSGT_ATTR_IQ_SOURCE,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_SWAP,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_ENABLED,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SET_TO_DEFAULT,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_LOAD_SETTINGS,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_STORE_SETTINGS,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_DELETE_SETTINGS,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SETTINGS_CATALOG,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_AM_FIRST,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_LEVEL_REFERENCE,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_OUTPUT_LEVEL_ERROR,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_NUMBER_OF_ITERACTIONS,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INTERACTIONS_STATUS,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_ACHIEVED_OUTPUT_LEVEL_ERROR,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_PEP,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_LEVEL,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INPUT_CREST_FACTOR,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_PEP,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_LEVEL,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_OUTPUT_CREST_FACTOR,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_AM_STATE,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_AM_PM_STATE,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INTERPOLATION,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_INVERT_CORRECTION_VALUES,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MAXIMUM_PEP_INPUT_POWER,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_MINIMUM_PEP_INPUT_POWER,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_PRE_GAIN,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_AM_FILE_CATALOG,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_AM_SELECT_FILE,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_PM_FILE_CATALOG,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_TABLE_AM_PM_SELECT_FILE,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_FILE_CATALOG,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_LOAD_FILE,
&g_RSSGT_ATTR_DIGITAL_PREDISTORTION_SHAPING_POLYNOMIAL_SAVE_FILE,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_ENABLED,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_DELAY,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_RATIO,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_LEAKAGE_I,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_LEAKAGE_Q,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_QUADRATURE_OFFSET,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_SKEW,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_PEAK_LEVEL,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_SIGNAL_LEVEL,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_OPTIMIZATION_ENABLED,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_OPTIMIZATION_MODE,
&g_RSSGT_ATTR_IQ_IMPAIRMENTS_CREST_FACTOR,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_ENABLED,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_DELAY,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_RATIO,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_LEAKAGE_I,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_LEAKAGE_Q,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_QUADRATURE_OFFSET,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_SKEW,
&g_RSSGT_ATTR_IQ_OUTPUT_IMPAIRMENTS_PHASE_OFFSET,
&g_RSSGT_ATTR_AWGN_ENABLED,
&g_RSSGT_ATTR_AWGN_MODE,
&g_RSSGT_ATTR_AWGN_BANDWIDTH,
&g_RSSGT_ATTR_AWGN_BANDWIDTH_RATIO,
&g_RSSGT_ATTR_AWGN_BANDWIDTH_NOISE,
&g_RSSGT_ATTR_AWGN_BIT_RATE,
&g_RSSGT_ATTR_AWGN_DISPLAY_MODE,
&g_RSSGT_ATTR_AWGN_DISPLAY_OUTPUT_RESULT,
&g_RSSGT_ATTR_AWGN_TARGET_CW_FREQUENCY_OFFSET,
&g_RSSGT_ATTR_AWGN_RESULTING_CW_FREQUENCY_OFFSET,
&g_RSSGT_ATTR_AWGN_NOISE_LEVEL_VIA,
&g_RSSGT_ATTR_AWGN_CARRIER_TO_NOISE_RATIO,
&g_RSSGT_ATTR_AWGN_EB_TO_N0,
&g_RSSGT_ATTR_AWGN_CARRIER_LEVEL,
&g_RSSGT_ATTR_AWGN_NOISE_LEVEL,
&g_RSSGT_ATTR_AWGN_NOISE_LEVEL_TOTAL,
&g_RSSGT_ATTR_AWGN_CARRIER_AND_NOISE_LEVEL,
&g_RSSGT_ATTR_AWGN_CARRIER_AND_NOISE_PEP,
&g_RSSGT_ATTR_AWGN_POWER_REFERENCE_MODE,
&g_RSSGT_ATTR_OUTPUT_ENABLED,
&g_RSSGT_ATTR_BB_OPERATION_MODE,
&g_RSSGT_ATTR_PATH_COUNT,
&g_RSSGT_ATTR_RF_FREQUENCY,
&g_RSSGT_ATTR_RF_FREQUENCY_OFFSET,
&g_RSSGT_ATTR_RF_DELTA_PHASE,
&g_RSSGT_ATTR_RESET_RF_DELTA_PHASE_DISPLAY,
&g_RSSGT_ATTR_PULM_ENABLED,
&g_RSSGT_ATTR_PULM_POLARITY,
&g_RSSGT_ATTR_PULM_SOURCE,
&g_RSSGT_ATTR_PULM_MODE,
&g_RSSGT_ATTR_PULM_PERIOD,
&g_RSSGT_ATTR_PULM_WIDTH,
&g_RSSGT_ATTR_PULM_DELAY,
&g_RSSGT_ATTR_PULM_DOUBLE_WIDTH,
&g_RSSGT_ATTR_PULM_DOUBLE_DELAY,
&g_RSSGT_ATTR_PULM_TRIGGER_MODE,
&g_RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_IMPEDANCE,
&g_RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_SLOPE,
&g_RSSGT_ATTR_PULM_TRIGGER_EXTERNAL_INPUT_GATE_POLARITY,
&g_RSSGT_ATTR_ALC_ENABLED,
&g_RSSGT_ATTR_ALC_SEARCH_ONCE,
&g_RSSGT_ATTR_ALC_DETECTOR_SENSITIVITY,
&g_RSSGT_ATTR_RF_AMPLITUDE,
&g_RSSGT_ATTR_RF_LEVEL_OFFSET,
&g_RSSGT_ATTR_RF_LEVEL,
&g_RSSGT_ATTR_RF_LEVEL_LIMIT,
&g_RSSGT_ATTR_RF_LEVEL_MODE,
&g_RSSGT_ATTR_RF_LEVEL_SETTING_CHARACTERISTIC,
&g_RSSGT_ATTR_RF_LEVEL_RANGE_MINIMUM,
&g_RSSGT_ATTR_RF_LEVEL_RANGE_MAXIMUM,
&g_RSSGT_ATTR_RF_PEP,
&g_RSSGT_ATTR_RF_LEVEL_RANGE_WARNINGS,
&g_RSSGT_ATTR_RF_ATTENUATOR_MODE,
&g_RSSGT_ATTR_RF_ATTENUATOR_LOWER_RANGE,
&g_RSSGT_ATTR_RF_ATTENUATOR_UPPER_RANGE,
&g_RSSGT_ATTR_RF_ATTENUATOR_RF_OFF_MODE,
&g_RSSGT_ATTR_RF_ATTENUATOR_SWITCH_OVER_OFFSET,
&g_RSSGT_ATTR_RF_ATTENUATION_DIGITAL,
&g_RSSGT_ATTR_POWER_ON_ENABLED,
&g_RSSGT_ATTR_USER_CORRECTION_ENABLED,
&g_RSSGT_ATTR_USER_CORRECTION_VALUE,
&g_RSSGT_ATTR_USER_CORRECTION_CATALOG,
&g_RSSGT_ATTR_USER_CORRECTION_SELECTED,
&g_RSSGT_ATTR_USER_CORRECTION_NUMBER_OF_FREQUENCIES,
&g_RSSGT_ATTR_USER_CORRECTION_NUMBER_OF_POWERS,
&g_RSSGT_ATTR_USER_CORRECTION_DELETE,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_CATALOG,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_EXTENSION,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_ASCII_FILE,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_CORRECTION_FILE,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_COLUMN_SEPARATOR,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_DECIMAL_SEPARATOR,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_MODE,
&g_RSSGT_ATTR_USER_CORRECTION_IMPORT_EXPORT_EXECUTE,
&g_RSSGT_ATTR_LOSC_SOURCE,
&g_RSSGT_ATTR_BBIN_ENABLED,
&g_RSSGT_ATTR_BBIN_MODE,
&g_RSSGT_ATTR_BBIN_IQ_SWAP,
&g_RSSGT_ATTR_BBIN_IQ_SKEW,
&g_RSSGT_ATTR_BBIN_CREST_FACTOR,
&g_RSSGT_ATTR_BBIN_MEASUREMENT_PERIOD,
&g_RSSGT_ATTR_BBIN_AUTO_LEVEL_SET_ENABLED,
&g_RSSGT_ATTR_BBIN_AUTO_LEVEL_SET,
&g_RSSGT_ATTR_BBIN_OVERLOAD_RESET,
&g_RSSGT_ATTR_BBIN_OVERLOAD_ENABLED,
&g_RSSGT_ATTR_BBIN_OVERLOAD_HOLD_ENABLED,
&g_RSSGT_ATTR_BBIN_RMS_POWER,
&g_RSSGT_ATTR_BBIN_CURRENT_SAMPLE_RATE,
&g_RSSGT_ATTR_BBIN_PATH_GAIN,
&g_RSSGT_ATTR_BBIN_FREQUENCY_OFFSET,
&g_RSSGT_ATTR_BBIN_EXTERNALLY_CONNECTED_ID,
&g_RSSGT_ATTR_BBIN_SAMPLE_RATE_SOURCE,
&g_RSSGT_ATTR_BBIN_OUTPUT_DELAY,
&g_RSSGT_ATTR_BBIN_IMPAIRMENTS_GAIN_IMBALANCE,
&g_RSSGT_ATTR_BBIN_IMPAIRMENTS_I_OFFSET,
&g_RSSGT_ATTR_BBIN_IMPAIRMENTS_Q_OFFSET,
&g_RSSGT_ATTR_POWER_UNIT,
&g_RSSGT_ATTR_POWER_FREQUENCY,
&g_RSSGT_ATTR_POWER_RECORDER_STATE,
&g_RSSGT_ATTR_POWER_OFFSET,
&g_RSSGT_ATTR_POWER_OFFSET_ENABLED,
&g_RSSGT_ATTR_POWER_SOURCE,
&g_RSSGT_ATTR_POWER_ZERO,
&g_RSSGT_ATTR_POWER_CONTINUOUS,
&g_RSSGT_ATTR_POWER_USE_SPARAMETERS,
&g_RSSGT_ATTR_POWER_DISPLAY_PERMANENT,
&g_RSSGT_ATTR_POWER_DISPLAY_PERMANENT_ENABLED,
&g_RSSGT_ATTR_POWER_FILTER_LENGTH,
&g_RSSGT_ATTR_POWER_FILTER_MODE,
&g_RSSGT_ATTR_POWER_FILTER_NS_RATIO,
&g_RSSGT_ATTR_POWER_FILTER_NS_RATIO_TIMEOUT,
&g_RSSGT_ATTR_POWER_FILTER_LENGTH_AUTO,
&g_RSSGT_ATTR_POWER_FILTER_SEARCH_ONCE,
&g_RSSGT_ATTR_POWER_SENSOR_DEVICE,
&g_RSSGT_ATTR_POWER_SENSOR_TYPE,
&g_RSSGT_ATTR_POWER_READ_POWER,
&g_RSSGT_ATTR_POWER_SENSOR_VERSION,
&g_RSSGT_ATTR_POWER_SENSOR_SERIAL_NUMBER,
&g_RSSGT_ATTR_POWER_DEFAULT_APERTURE_TIME_ENABLED,
&g_RSSGT_ATTR_POWER_APERTURE_TIME,
&g_RSSGT_ATTR_POWER_BASEBAND_ADD_MEASUREMENT,
&g_RSSGT_ATTR_POWER_BASEBAND_CHANGE_MEASUREMENT,
&g_RSSGT_ATTR_POWER_BASEBAND_DELETE_MEASUREMENT,
&g_RSSGT_ATTR_POWER_BASEBAND_EXECUTE_MEASUREMENT,
&g_RSSGT_ATTR_POWER_BASEBAND_ABORT,
&g_RSSGT_ATTR_PSER_STATE,
&g_RSSGT_ATTR_PSER_TARGET,
&g_RSSGT_ATTR_PSER_TOL,
&g_RSSGT_ATTR_PSER_TEST,
&g_RSSGT_ATTR_PSER_TRACK,
&g_RSSGT_ATTR_PSER_SENSOR,
&g_RSSGT_ATTR_PSER_APER,
&g_RSSGT_ATTR_CLOCK_INPUT_SLOPE,
&g_RSSGT_ATTR_CLOCK_MODE,
&g_RSSGT_ATTR_CLOCK_INPUT_FREQUENCY,
&g_RSSGT_ATTR_RESTART,
&g_RSSGT_ATTR_STANDBY,
&g_RSSGT_ATTR_UNLOCK,
&g_RSSGT_ATTR_USER_PATH,
&g_RSSGT_ATTR_ID_QUERY_RESPONSE,
&g_RSSGT_ATTR_CALIBRATION_ALL,
&g_RSSGT_ATTR_CALIBRATION_FREQUENCY,
&g_RSSGT_ATTR_CALIBRATION_FREQUENCY_TEMPERATURE,
&g_RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_FULL,
&g_RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_LOCAL,
&g_RSSGT_ATTR_CALIBRATION_IQ_MODULATOR_TEMPERATURE,
&g_RSSGT_ATTR_CALIBRATION_LEVEL,
&g_RSSGT_ATTR_CALIBRATION_LEVEL_TEMPERATURE,
&g_RSSGT_ATTR_CALIBRATION_IQ_INPUT,
&g_RSSGT_ATTR_TEST_ALL_START,
&g_RSSGT_ATTR_TEST_ALL_RESULT,
&g_RSSGT_ATTR_TEST_KEYBOARD,
&g_RSSGT_ATTR_TEST_EXTERNAL_IQ_DEVICES,
&g_RSSGT_ATTR_TEST_BASEBAND_INPUT,
&g_RSSGT_ATTR_DIAGNOSTIC_TEST_POINTS,
&g_RSSGT_ATTR_MMEMORY_CHANGE_DIRECTORY,
&g_RSSGT_ATTR_MMEMORY_DELETE,
&g_RSSGT_ATTR_MMEMORY_MAKE_DIRECTORY,
&g_RSSGT_ATTR_MMEMORY_REMOVE_DIRECTORY,
&g_RSSGT_ATTR_SYSTEM_FACTORY_PRESET,
&g_RSSGT_ATTR_SYSTEM_ERROR,
&g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_ALL,
&g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_CODE_ALL,
&g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_CODE_NEXT,
&g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_COUNT,
&g_RSSGT_ATTR_SYSTEM_ERROR_QUEUE_NEXT,
&g_RSSGT_ATTR_SYSTEM_ERROR_ALL,
&g_RSSGT_ATTR_SYSTEM_VERSION,
&g_RSSGT_ATTR_SYSTEM_PRESET,
&g_RSSGT_ATTR_SYSTEM_STARTUP_COMPLETE,
&g_RSSGT_ATTR_SYSTEM_USB_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_GPIB_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_GPIB_ADDRESS,
&g_RSSGT_ATTR_SYSTEM_GPIB_LINE_TERMINATOR,
&g_RSSGT_ATTR_SYSTEM_SERIAL_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_SERIAL_BAUD,
&g_RSSGT_ATTR_SYSTEM_SERIAL_PARITY,
&g_RSSGT_ATTR_SYSTEM_SERIAL_STOP_BITS,
&g_RSSGT_ATTR_SYSTEM_HISLIP_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_PCI_EXPRESS_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_SOCKET_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_OPERATING_SYSTEM,
&g_RSSGT_ATTR_SYSTEM_UPTIME,
&g_RSSGT_ATTR_SYSTEM_NETWORK_RESTART,
&g_RSSGT_ATTR_SYSTEM_NETWORK_STATUS,
&g_RSSGT_ATTR_SYSTEM_NETWORK_RESOURCE,
&g_RSSGT_ATTR_SYSTEM_NETWORK_MAC_ADDRESS,
&g_RSSGT_ATTR_SYSTEM_NETWORK_HOST_NAME,
&g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS,
&g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_SUBNET_MASK,
&g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_GATEWAY,
&g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_MODE,
&g_RSSGT_ATTR_SYSTEM_NETWORK_IP_ADDRESS_DNS,
&g_RSSGT_ATTR_STATUS_PRESET,
&g_RSSGT_ATTR_UNIT_ANGLE,
&g_RSSGT_ATTR_UNIT_POWER,
&g_RSSGT_ATTR_CONNECTOR_OUTPUT,
&g_RSSGT_ATTR_CONNECTOR_OPERATION_MODE,
&g_RSSGT_ATTR_CONNECTOR_THRESHOLD,
&g_RSSGT_ATTR_CONNECTOR_CLOCK_IMPEDANCE,
&g_RSSGT_ATTR_CONNECTOR_CLOCK_SLOPE,
&g_RSSGT_ATTR_CONNECTOR_TRIGGER_IMPEDANCE,
&g_RSSGT_ATTR_CONNECTOR_TRIGGER_SLOPE,
&g_RSSGT_ATTR_FAST_SPEED_RF_OUTPUT_FREQUENCY,
&g_RSSGT_ATTR_FAST_SPEED_RF_OUTPUT_LEVEL,
&g_RSSGT_ATTR_FORMAT_SEQUENCE_OF_BYTES,
&g_RSSGT_ATTR_FORMAT_STATUS_REGISTER,
&g_RSSGT_ATTR_FORMAT_DATA,
&g_RSSGT_ATTR_TIME_ZONE,
&g_RSSGT_ATTR_TIME_ZONE_CATALOG,
&g_RSSGT_ATTR_INIT_SW_TRIGGER,

// manually added
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_MODE,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_BIAS_COUPLING_STATE,
&g_RSSGT_ATTR_IQ_OUTPUT_ANALOG_BIAS_I,

NULL
};
